/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Data Flow Connection</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowConnection#getCommunicationType <em>Communication Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowConnection#getInitialElements <em>Initial Elements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowConnection#getMaxElements <em>Max Elements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowConnection#isMultiQueued <em>Multi Queued</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowConnection#getProvider <em>Provider</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.DataFlowConnection#getRequesters <em>Requesters</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection()
 * @model
 * @generated
 */
public interface DataFlowConnection extends Connection {
	/**
	 * Returns the value of the '<em><b>Communication Type</b></em>' attribute.
	 * The default value is <code>"EventBased"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.DataFlowCommunicationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Communication Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Communication Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.DataFlowCommunicationType
	 * @see #setCommunicationType(DataFlowCommunicationType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection_CommunicationType()
	 * @model default="EventBased" required="true"
	 * @generated
	 */
	DataFlowCommunicationType getCommunicationType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowConnection#getCommunicationType <em>Communication Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Communication Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.DataFlowCommunicationType
	 * @see #getCommunicationType()
	 * @generated
	 */
	void setCommunicationType(DataFlowCommunicationType value);

	/**
	 * Returns the value of the '<em><b>Initial Elements</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial Elements</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial Elements</em>' attribute.
	 * @see #setInitialElements(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection_InitialElements()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getInitialElements();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowConnection#getInitialElements <em>Initial Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initial Elements</em>' attribute.
	 * @see #getInitialElements()
	 * @generated
	 */
	void setInitialElements(int value);

	/**
	 * Returns the value of the '<em><b>Max Elements</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Elements</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Elements</em>' attribute.
	 * @see #setMaxElements(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection_MaxElements()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getMaxElements();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowConnection#getMaxElements <em>Max Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Elements</em>' attribute.
	 * @see #getMaxElements()
	 * @generated
	 */
	void setMaxElements(int value);

	/**
	 * Returns the value of the '<em><b>Multi Queued</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Multi Queued</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Multi Queued</em>' attribute.
	 * @see #setMultiQueued(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection_MultiQueued()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isMultiQueued();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowConnection#isMultiQueued <em>Multi Queued</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Multi Queued</em>' attribute.
	 * @see #isMultiQueued()
	 * @generated
	 */
	void setMultiQueued(boolean value);

	/**
	 * Returns the value of the '<em><b>Provider</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.VariableWriteAccess#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Provider</em>' reference.
	 * @see #setProvider(VariableWriteAccess)
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection_Provider()
	 * @see com.inchron.realtime.root.model.VariableWriteAccess#getConnection
	 * @model opposite="connection" required="true"
	 * @generated
	 */
	VariableWriteAccess getProvider();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.DataFlowConnection#getProvider <em>Provider</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Provider</em>' reference.
	 * @see #getProvider()
	 * @generated
	 */
	void setProvider(VariableWriteAccess value);

	/**
	 * Returns the value of the '<em><b>Requesters</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.VariableReadAccess}.
	 * It is bidirectional and its opposite is '{@link com.inchron.realtime.root.model.VariableReadAccess#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Requesters</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Requesters</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getDataFlowConnection_Requesters()
	 * @see com.inchron.realtime.root.model.VariableReadAccess#getConnection
	 * @model opposite="connection" required="true"
	 * @generated
	 */
	EList<VariableReadAccess> getRequesters();

} // DataFlowConnection
