/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Sequence</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.EventSequence#isOutOfOrderReset <em>Out Of Order Reset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.EventSequence#getSequence <em>Sequence</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getEventSequence()
 * @model
 * @generated
 */
public interface EventSequence extends EventChain {
	/**
	 * Returns the value of the '<em><b>Out Of Order Reset</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Out Of Order Reset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Out Of Order Reset</em>' attribute.
	 * @see #setOutOfOrderReset(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getEventSequence_OutOfOrderReset()
	 * @model default="false"
	 * @generated
	 */
	boolean isOutOfOrderReset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.EventSequence#isOutOfOrderReset <em>Out Of Order Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Out Of Order Reset</em>' attribute.
	 * @see #isOutOfOrderReset()
	 * @generated
	 */
	void setOutOfOrderReset(boolean value);

	/**
	 * Returns the value of the '<em><b>Sequence</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ConditionalTraceEvent}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sequence</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sequence</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getEventSequence_Sequence()
	 * @model containment="true"
	 * @generated
	 */
	EList<ConditionalTraceEvent> getSequence();

} // EventSequence
