/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Memory Region</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getBase <em>Base</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getFile <em>File</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getFlags <em>Flags</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getPages <em>Pages</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getPageSize <em>Page Size</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getSections <em>Sections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.MemoryRegion#getSharedName <em>Shared Name</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion()
 * @model
 * @generated
 */
public interface MemoryRegion extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Base</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Base</em>' attribute.
	 * @see #setBase(long)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_Base()
	 * @model default="0" required="true"
	 * @generated
	 */
	long getBase();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getBase <em>Base</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Base</em>' attribute.
	 * @see #getBase()
	 * @generated
	 */
	void setBase(long value);

	/**
	 * Returns the value of the '<em><b>File</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>File</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>File</em>' attribute.
	 * @see #setFile(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_File()
	 * @model default="" required="true"
	 * @generated
	 */
	String getFile();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getFile <em>File</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>File</em>' attribute.
	 * @see #getFile()
	 * @generated
	 */
	void setFile(String value);

	/**
	 * Returns the value of the '<em><b>Flags</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Flags</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Flags</em>' attribute.
	 * @see #setFlags(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_Flags()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getFlags();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getFlags <em>Flags</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Flags</em>' attribute.
	 * @see #getFlags()
	 * @generated
	 */
	void setFlags(int value);

	/**
	 * Returns the value of the '<em><b>Pages</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pages</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pages</em>' attribute.
	 * @see #setPages(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_Pages()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getPages();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getPages <em>Pages</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pages</em>' attribute.
	 * @see #getPages()
	 * @generated
	 */
	void setPages(int value);

	/**
	 * Returns the value of the '<em><b>Page Size</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Page Size</em>' attribute.
	 * @see #setPageSize(long)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_PageSize()
	 * @model default="0" required="true"
	 * @generated
	 */
	long getPageSize();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getPageSize <em>Page Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Page Size</em>' attribute.
	 * @see #getPageSize()
	 * @generated
	 */
	void setPageSize(long value);

	/**
	 * Returns the value of the '<em><b>Sections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sections</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sections</em>' attribute.
	 * @see #setSections(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_Sections()
	 * @model required="true"
	 * @generated
	 */
	String getSections();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getSections <em>Sections</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sections</em>' attribute.
	 * @see #getSections()
	 * @generated
	 */
	void setSections(String value);

	/**
	 * Returns the value of the '<em><b>Shared Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Shared Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Shared Name</em>' attribute.
	 * @see #setSharedName(String)
	 * @see com.inchron.realtime.root.model.ModelPackage#getMemoryRegion_SharedName()
	 * @model required="true"
	 * @generated
	 */
	String getSharedName();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.MemoryRegion#getSharedName <em>Shared Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Shared Name</em>' attribute.
	 * @see #getSharedName()
	 * @generated
	 */
	void setSharedName(String value);

} // MemoryRegion
