/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.model.fmi.ModelDescription;

import com.inchron.realtime.root.model.memory.Interconnect;
import com.inchron.realtime.root.model.memory.Memory;

import com.inchron.realtime.root.model.peripheral.Bus;
import com.inchron.realtime.root.model.peripheral.PortConnection;

import com.inchron.realtime.root.model.requirement.Requirement;

import com.inchron.realtime.root.model.stimulation.StimulationScenario;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Model#getBusPeripherals <em>Bus Peripherals</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getClocks <em>Clocks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getCpus <em>Cpus</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getConnections <em>Connections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getEventChains <em>Event Chains</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getFmi <em>Fmi</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getGeneralInfo <em>General Info</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getGlobalModeConditions <em>Global Mode Conditions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getGlobalModeGroups <em>Global Mode Groups</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getInterconnects <em>Interconnects</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getMemories <em>Memories</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#isOmitCallNestingDiagram <em>Omit Call Nesting Diagram</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#isOmitImplicitEventChains <em>Omit Implicit Event Chains</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#isOmitStackDiagram <em>Omit Stack Diagram</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getPeripheralPortConnections <em>Peripheral Port Connections</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getRequirements <em>Requirements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getStimulationScenarios <em>Stimulation Scenarios</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getDefaultScenario <em>Default Scenario</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getSystems <em>Systems</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Model#getTraceEvents <em>Trace Events</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getModel()
 * @model
 * @generated
 */
public interface Model extends ModelObject, ContainerElement {
	/**
	 * Returns the value of the '<em><b>Bus Peripherals</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.Bus}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bus Peripherals</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bus Peripherals</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_BusPeripherals()
	 * @model containment="true"
	 * @generated
	 */
	EList<Bus> getBusPeripherals();

	/**
	 * Returns the value of the '<em><b>Clocks</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Clock}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Clocks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Clocks</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Clocks()
	 * @model containment="true"
	 * @generated
	 */
	EList<Clock> getClocks();

	/**
	 * Returns the value of the '<em><b>Cpus</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Cpu}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cpus</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cpus</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Cpus()
	 * @model containment="true"
	 * @generated
	 */
	EList<Cpu> getCpus();

	/**
	 * Returns the value of the '<em><b>Connections</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Connection}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connections</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connections</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Connections()
	 * @model containment="true"
	 * @generated
	 */
	EList<Connection> getConnections();

	/**
	 * Returns the value of the '<em><b>Event Chains</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.EventChain}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Chains</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Chains</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_EventChains()
	 * @model containment="true"
	 * @generated
	 */
	EList<EventChain> getEventChains();

	/**
	 * Returns the value of the '<em><b>Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Event}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Events</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Events()
	 * @model containment="true"
	 * @generated
	 */
	EList<Event> getEvents();

	/**
	 * Returns the value of the '<em><b>Fmi</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Fmi</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Fmi</em>' containment reference.
	 * @see #setFmi(ModelDescription)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Fmi()
	 * @model containment="true"
	 * @generated
	 */
	ModelDescription getFmi();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Model#getFmi <em>Fmi</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Fmi</em>' containment reference.
	 * @see #getFmi()
	 * @generated
	 */
	void setFmi(ModelDescription value);

	/**
	 * Returns the value of the '<em><b>General Info</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>General Info</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>General Info</em>' containment reference.
	 * @see #setGeneralInfo(GeneralInfo)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_GeneralInfo()
	 * @model containment="true"
	 * @generated
	 */
	GeneralInfo getGeneralInfo();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Model#getGeneralInfo <em>General Info</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>General Info</em>' containment reference.
	 * @see #getGeneralInfo()
	 * @generated
	 */
	void setGeneralInfo(GeneralInfo value);

	/**
	 * Returns the value of the '<em><b>Global Mode Conditions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ModeCondition}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Global Mode Conditions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_GlobalModeConditions()
	 * @model containment="true"
	 * @generated
	 */
	EList<ModeCondition> getGlobalModeConditions();

	/**
	 * Returns the value of the '<em><b>Global Mode Groups</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.ModeGroup}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Global Mode Groups</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Global Mode Groups</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_GlobalModeGroups()
	 * @model containment="true"
	 * @generated
	 */
	EList<ModeGroup> getGlobalModeGroups();

	/**
	 * Returns the value of the '<em><b>Interconnects</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.Interconnect}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interconnects</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interconnects</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Interconnects()
	 * @model containment="true"
	 * @generated
	 */
	EList<Interconnect> getInterconnects();

	/**
	 * Returns the value of the '<em><b>Memories</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.memory.Memory}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Memories</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Memories</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Memories()
	 * @model containment="true"
	 * @generated
	 */
	EList<Memory> getMemories();

	/**
	 * Returns the value of the '<em><b>Omit Call Nesting Diagram</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Omit Call Nesting Diagram</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Omit Call Nesting Diagram</em>' attribute.
	 * @see #setOmitCallNestingDiagram(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_OmitCallNestingDiagram()
	 * @model default="true"
	 * @generated
	 */
	boolean isOmitCallNestingDiagram();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Model#isOmitCallNestingDiagram <em>Omit Call Nesting Diagram</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Omit Call Nesting Diagram</em>' attribute.
	 * @see #isOmitCallNestingDiagram()
	 * @generated
	 */
	void setOmitCallNestingDiagram(boolean value);

	/**
	 * Returns the value of the '<em><b>Omit Implicit Event Chains</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Omit Implicit Event Chains</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Omit Implicit Event Chains</em>' attribute.
	 * @see #setOmitImplicitEventChains(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_OmitImplicitEventChains()
	 * @model default="true"
	 * @generated
	 */
	boolean isOmitImplicitEventChains();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Model#isOmitImplicitEventChains <em>Omit Implicit Event Chains</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Omit Implicit Event Chains</em>' attribute.
	 * @see #isOmitImplicitEventChains()
	 * @generated
	 */
	void setOmitImplicitEventChains(boolean value);

	/**
	 * Returns the value of the '<em><b>Omit Stack Diagram</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Omit Stack Diagram</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Omit Stack Diagram</em>' attribute.
	 * @see #setOmitStackDiagram(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_OmitStackDiagram()
	 * @model default="true"
	 * @generated
	 */
	boolean isOmitStackDiagram();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Model#isOmitStackDiagram <em>Omit Stack Diagram</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Omit Stack Diagram</em>' attribute.
	 * @see #isOmitStackDiagram()
	 * @generated
	 */
	void setOmitStackDiagram(boolean value);

	/**
	 * Returns the value of the '<em><b>Peripheral Port Connections</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.PortConnection}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Peripheral Port Connections</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Peripheral Port Connections</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_PeripheralPortConnections()
	 * @model containment="true"
	 * @generated
	 */
	EList<PortConnection> getPeripheralPortConnections();

	/**
	 * Returns the value of the '<em><b>Requirements</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.requirement.Requirement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Requirements</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Requirements</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Requirements()
	 * @model containment="true"
	 * @generated
	 */
	EList<Requirement> getRequirements();

	/**
	 * Returns the value of the '<em><b>Stimulation Scenarios</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.stimulation.StimulationScenario}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stimulation Scenarios</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stimulation Scenarios</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_StimulationScenarios()
	 * @model containment="true"
	 * @generated
	 */
	EList<StimulationScenario> getStimulationScenarios();

	/**
	 * Returns the value of the '<em><b>Default Scenario</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Scenario</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Scenario</em>' reference.
	 * @see #setDefaultScenario(StimulationScenario)
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_DefaultScenario()
	 * @model
	 * @generated
	 */
	StimulationScenario getDefaultScenario();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Model#getDefaultScenario <em>Default Scenario</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Scenario</em>' reference.
	 * @see #getDefaultScenario()
	 * @generated
	 */
	void setDefaultScenario(StimulationScenario value);

	/**
	 * Returns the value of the '<em><b>Systems</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.System}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Systems</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Systems</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_Systems()
	 * @model containment="true"
	 * @generated
	 */
	EList<com.inchron.realtime.root.model.System> getSystems();

	/**
	 * Returns the value of the '<em><b>Trace Events</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.TraceEvent}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trace Events</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trace Events</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getModel_TraceEvents()
	 * @model containment="true"
	 * @generated
	 */
	EList<TraceEvent> getTraceEvents();

} // Model
