/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scheduling Entry</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.SchedulingEntry#getItem <em>Item</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SchedulingEntry#getSlotLength <em>Slot Length</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSchedulingEntry()
 * @model
 * @generated
 */
public interface SchedulingEntry extends EObject {
	/**
	 * Returns the value of the '<em><b>Item</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Item</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Item</em>' reference.
	 * @see #setItem(Schedulable)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSchedulingEntry_Item()
	 * @model required="true"
	 * @generated
	 */
	Schedulable getItem();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SchedulingEntry#getItem <em>Item</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Item</em>' reference.
	 * @see #getItem()
	 * @generated
	 */
	void setItem(Schedulable value);

	/**
	 * Returns the value of the '<em><b>Slot Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Slot Length</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Slot Length</em>' containment reference.
	 * @see #setSlotLength(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSchedulingEntry_SlotLength()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getSlotLength();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SchedulingEntry#getSlotLength <em>Slot Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Slot Length</em>' containment reference.
	 * @see #getSlotLength()
	 * @generated
	 */
	void setSlotLength(Time value);

} // SchedulingEntry
