/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Trace Object</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.TraceObject#getObjectId <em>Object Id</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getTraceObject()
 * @model abstract="true"
 * @generated
 */
public interface TraceObject extends EObject {
	/**
	 * Returns the value of the '<em><b>Object Id</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Object Id</em>' attribute.
	 * @see #isSetObjectId()
	 * @see #unsetObjectId()
	 * @see #setObjectId(int)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTraceObject_ObjectId()
	 * @model default="0" unsettable="true"
	 * @generated
	 */
	int getObjectId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TraceObject#getObjectId <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Object Id</em>' attribute.
	 * @see #isSetObjectId()
	 * @see #unsetObjectId()
	 * @see #getObjectId()
	 * @generated
	 */
	void setObjectId(int value);

	/**
	 * Unsets the value of the '{@link com.inchron.realtime.root.model.TraceObject#getObjectId <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetObjectId()
	 * @see #getObjectId()
	 * @see #setObjectId(int)
	 * @generated
	 */
	void unsetObjectId();

	/**
	 * Returns whether the value of the '{@link com.inchron.realtime.root.model.TraceObject#getObjectId <em>Object Id</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Object Id</em>' attribute is set.
	 * @see #unsetObjectId()
	 * @see #getObjectId()
	 * @see #setObjectId(int)
	 * @generated
	 */
	boolean isSetObjectId();

} // TraceObject
