/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Variable Write Access Policy</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.ModelPackage#getVariableWriteAccessPolicy()
 * @model
 * @generated
 */
public enum VariableWriteAccessPolicy implements Enumerator {
	/**
	 * The '<em><b>Error Drop</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ERROR_DROP_VALUE
	 * @generated
	 * @ordered
	 */
	ERROR_DROP(0, "ErrorDrop", "ErrorDrop"),

	/**
	 * The '<em><b>Silent Drop</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SILENT_DROP_VALUE
	 * @generated
	 * @ordered
	 */
	SILENT_DROP(1, "SilentDrop", "SilentDrop"),

	/**
	 * The '<em><b>Error Overwrite</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ERROR_OVERWRITE_VALUE
	 * @generated
	 * @ordered
	 */
	ERROR_OVERWRITE(2, "ErrorOverwrite", "ErrorOverwrite"), /**
	 * The '<em><b>Silent Overwrite</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SILENT_OVERWRITE_VALUE
	 * @generated
	 * @ordered
	 */
	SILENT_OVERWRITE(3, "SilentOverwrite", "SilentOverwrite");

	/**
	 * The '<em><b>Error Drop</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Error Drop</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ERROR_DROP
	 * @model name="ErrorDrop"
	 * @generated
	 * @ordered
	 */
	public static final int ERROR_DROP_VALUE = 0;

	/**
	 * The '<em><b>Silent Drop</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Silent Drop</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SILENT_DROP
	 * @model name="SilentDrop"
	 * @generated
	 * @ordered
	 */
	public static final int SILENT_DROP_VALUE = 1;

	/**
	 * The '<em><b>Error Overwrite</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Error Overwrite</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ERROR_OVERWRITE
	 * @model name="ErrorOverwrite"
	 * @generated
	 * @ordered
	 */
	public static final int ERROR_OVERWRITE_VALUE = 2;

	/**
	 * The '<em><b>Silent Overwrite</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Silent Overwrite</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SILENT_OVERWRITE
	 * @model name="SilentOverwrite"
	 * @generated
	 * @ordered
	 */
	public static final int SILENT_OVERWRITE_VALUE = 3;

	/**
	 * An array of all the '<em><b>Variable Write Access Policy</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final VariableWriteAccessPolicy[] VALUES_ARRAY =
		new VariableWriteAccessPolicy[] {
			ERROR_DROP,
			SILENT_DROP,
			ERROR_OVERWRITE,
			SILENT_OVERWRITE,
		};

	/**
	 * A public read-only list of all the '<em><b>Variable Write Access Policy</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<VariableWriteAccessPolicy> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Variable Write Access Policy</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param literal the literal.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static VariableWriteAccessPolicy get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			VariableWriteAccessPolicy result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Variable Write Access Policy</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param name the name.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static VariableWriteAccessPolicy getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			VariableWriteAccessPolicy result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Variable Write Access Policy</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the integer value.
	 * @return the matching enumerator or <code>null</code>.
	 * @generated
	 */
	public static VariableWriteAccessPolicy get(int value) {
		switch (value) {
			case ERROR_DROP_VALUE: return ERROR_DROP;
			case SILENT_DROP_VALUE: return SILENT_DROP;
			case ERROR_OVERWRITE_VALUE: return ERROR_OVERWRITE;
			case SILENT_OVERWRITE_VALUE: return SILENT_OVERWRITE;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private VariableWriteAccessPolicy(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //VariableWriteAccessPolicy
