/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AR System</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.ARSystem#getOsConfig <em>Os Config</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.ARSystem#isIsOsek <em>Is Osek</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getARSystem()
 * @model
 * @generated
 */
public interface ARSystem extends com.inchron.realtime.root.model.System {
	/**
	 * Returns the value of the '<em><b>Os Config</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Os Config</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Os Config</em>' containment reference.
	 * @see #setOsConfig(OsConfig)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getARSystem_OsConfig()
	 * @model containment="true"
	 * @generated
	 */
	OsConfig getOsConfig();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.ARSystem#getOsConfig <em>Os Config</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Os Config</em>' containment reference.
	 * @see #getOsConfig()
	 * @generated
	 */
	void setOsConfig(OsConfig value);

	/**
	 * Returns the value of the '<em><b>Is Osek</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Osek</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Osek</em>' attribute.
	 * @see #setIsOsek(boolean)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getARSystem_IsOsek()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isIsOsek();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.ARSystem#isIsOsek <em>Is Osek</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Osek</em>' attribute.
	 * @see #isIsOsek()
	 * @generated
	 */
	void setIsOsek(boolean value);

} // ARSystem
