/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage
 * @generated
 */
public interface AutosarFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AutosarFactory eINSTANCE = com.inchron.realtime.root.model.autosar.impl.AutosarFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>AR System</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>AR System</em>'.
	 * @generated
	 */
	ARSystem createARSystem();

	/**
	 * Returns a new object of class '<em>Clear Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Clear Event</em>'.
	 * @generated
	 */
	ClearEvent createClearEvent();

	/**
	 * Returns a new object of class '<em>Operation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Operation</em>'.
	 * @generated
	 */
	Operation createOperation();

	/**
	 * Returns a new object of class '<em>Os Alarm</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Alarm</em>'.
	 * @generated
	 */
	OsAlarm createOsAlarm();

	/**
	 * Returns a new object of class '<em>Os Alarm Action</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Alarm Action</em>'.
	 * @generated
	 */
	OsAlarmAction createOsAlarmAction();

	/**
	 * Returns a new object of class '<em>Os Application</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Application</em>'.
	 * @generated
	 */
	OsApplication createOsApplication();

	/**
	 * Returns a new object of class '<em>Os Config</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Config</em>'.
	 * @generated
	 */
	OsConfig createOsConfig();

	/**
	 * Returns a new object of class '<em>Os Counter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Counter</em>'.
	 * @generated
	 */
	OsCounter createOsCounter();

	/**
	 * Returns a new object of class '<em>Os Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Event</em>'.
	 * @generated
	 */
	OsEvent createOsEvent();

	/**
	 * Returns a new object of class '<em>Os Expiry Point</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Expiry Point</em>'.
	 * @generated
	 */
	OsExpiryPoint createOsExpiryPoint();

	/**
	 * Returns a new object of class '<em>Os Isr</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Isr</em>'.
	 * @generated
	 */
	OsIsr createOsIsr();

	/**
	 * Returns a new object of class '<em>Os Resource</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Resource</em>'.
	 * @generated
	 */
	OsResource createOsResource();

	/**
	 * Returns a new object of class '<em>Os Schedule Table</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Schedule Table</em>'.
	 * @generated
	 */
	OsScheduleTable createOsScheduleTable();

	/**
	 * Returns a new object of class '<em>Os Spinlock</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Spinlock</em>'.
	 * @generated
	 */
	OsSpinlock createOsSpinlock();

	/**
	 * Returns a new object of class '<em>Os Task</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Os Task</em>'.
	 * @generated
	 */
	OsTask createOsTask();

	/**
	 * Returns a new object of class '<em>Resume OS Interrupts</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Resume OS Interrupts</em>'.
	 * @generated
	 */
	ResumeOSInterrupts createResumeOSInterrupts();

	/**
	 * Returns a new object of class '<em>Runnable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Runnable</em>'.
	 * @generated
	 */
	Runnable createRunnable();

	/**
	 * Returns a new object of class '<em>Server Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Server Call</em>'.
	 * @generated
	 */
	ServerCall createServerCall();

	/**
	 * Returns a new object of class '<em>Suspend OS Interrupts</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Suspend OS Interrupts</em>'.
	 * @generated
	 */
	SuspendOSInterrupts createSuspendOSInterrupts();

	/**
	 * Returns a new object of class '<em>Sw Component</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sw Component</em>'.
	 * @generated
	 */
	SwComponent createSwComponent();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	AutosarPackage getAutosarPackage();

} //AutosarFactory
