/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.impl;

import com.inchron.realtime.root.model.fmi.FmiPackage;
import com.inchron.realtime.root.model.fmi.ModelDescription;

import com.inchron.realtime.root.model.fmi.type.SimpleType;

import com.inchron.realtime.root.model.fmi.unit.Unit;

import com.inchron.realtime.root.model.fmi.variable.Real;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Description</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl#getSeed <em>Seed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl#getTime <em>Time</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl#getTypeDefinitions <em>Type Definitions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.impl.ModelDescriptionImpl#getUnitDefinitions <em>Unit Definitions</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ModelDescriptionImpl extends MinimalEObjectImpl.Container implements ModelDescription {
	/**
	 * The cached value of the '{@link #getSeed() <em>Seed</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSeed()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.fmi.variable.Integer seed;

	/**
	 * The cached value of the '{@link #getTime() <em>Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTime()
	 * @generated
	 * @ordered
	 */
	protected Real time;

	/**
	 * The cached value of the '{@link #getTypeDefinitions() <em>Type Definitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeDefinitions()
	 * @generated
	 * @ordered
	 */
	protected EList<SimpleType> typeDefinitions;

	/**
	 * The cached value of the '{@link #getUnitDefinitions() <em>Unit Definitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUnitDefinitions()
	 * @generated
	 * @ordered
	 */
	protected EList<Unit> unitDefinitions;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelDescriptionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return FmiPackage.Literals.MODEL_DESCRIPTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.fmi.variable.Integer getSeed() {
		return seed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSeed(com.inchron.realtime.root.model.fmi.variable.Integer newSeed, NotificationChain msgs) {
		com.inchron.realtime.root.model.fmi.variable.Integer oldSeed = seed;
		seed = newSeed;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, FmiPackage.MODEL_DESCRIPTION__SEED, oldSeed, newSeed);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSeed(com.inchron.realtime.root.model.fmi.variable.Integer newSeed) {
		if (newSeed != seed) {
			NotificationChain msgs = null;
			if (seed != null)
				msgs = ((InternalEObject)seed).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - FmiPackage.MODEL_DESCRIPTION__SEED, null, msgs);
			if (newSeed != null)
				msgs = ((InternalEObject)newSeed).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - FmiPackage.MODEL_DESCRIPTION__SEED, null, msgs);
			msgs = basicSetSeed(newSeed, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FmiPackage.MODEL_DESCRIPTION__SEED, newSeed, newSeed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Real getTime() {
		return time;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTime(Real newTime, NotificationChain msgs) {
		Real oldTime = time;
		time = newTime;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, FmiPackage.MODEL_DESCRIPTION__TIME, oldTime, newTime);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTime(Real newTime) {
		if (newTime != time) {
			NotificationChain msgs = null;
			if (time != null)
				msgs = ((InternalEObject)time).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - FmiPackage.MODEL_DESCRIPTION__TIME, null, msgs);
			if (newTime != null)
				msgs = ((InternalEObject)newTime).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - FmiPackage.MODEL_DESCRIPTION__TIME, null, msgs);
			msgs = basicSetTime(newTime, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FmiPackage.MODEL_DESCRIPTION__TIME, newTime, newTime));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SimpleType> getTypeDefinitions() {
		if (typeDefinitions == null) {
			typeDefinitions = new EObjectContainmentEList.Unsettable<SimpleType>(SimpleType.class, this, FmiPackage.MODEL_DESCRIPTION__TYPE_DEFINITIONS);
		}
		return typeDefinitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetTypeDefinitions() {
		if (typeDefinitions != null) ((InternalEList.Unsettable<?>)typeDefinitions).unset();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetTypeDefinitions() {
		return typeDefinitions != null && ((InternalEList.Unsettable<?>)typeDefinitions).isSet();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Unit> getUnitDefinitions() {
		if (unitDefinitions == null) {
			unitDefinitions = new EObjectContainmentEList.Unsettable<Unit>(Unit.class, this, FmiPackage.MODEL_DESCRIPTION__UNIT_DEFINITIONS);
		}
		return unitDefinitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetUnitDefinitions() {
		if (unitDefinitions != null) ((InternalEList.Unsettable<?>)unitDefinitions).unset();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetUnitDefinitions() {
		return unitDefinitions != null && ((InternalEList.Unsettable<?>)unitDefinitions).isSet();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case FmiPackage.MODEL_DESCRIPTION__SEED:
				return basicSetSeed(null, msgs);
			case FmiPackage.MODEL_DESCRIPTION__TIME:
				return basicSetTime(null, msgs);
			case FmiPackage.MODEL_DESCRIPTION__TYPE_DEFINITIONS:
				return ((InternalEList<?>)getTypeDefinitions()).basicRemove(otherEnd, msgs);
			case FmiPackage.MODEL_DESCRIPTION__UNIT_DEFINITIONS:
				return ((InternalEList<?>)getUnitDefinitions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case FmiPackage.MODEL_DESCRIPTION__SEED:
				return getSeed();
			case FmiPackage.MODEL_DESCRIPTION__TIME:
				return getTime();
			case FmiPackage.MODEL_DESCRIPTION__TYPE_DEFINITIONS:
				return getTypeDefinitions();
			case FmiPackage.MODEL_DESCRIPTION__UNIT_DEFINITIONS:
				return getUnitDefinitions();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case FmiPackage.MODEL_DESCRIPTION__SEED:
				setSeed((com.inchron.realtime.root.model.fmi.variable.Integer)newValue);
				return;
			case FmiPackage.MODEL_DESCRIPTION__TIME:
				setTime((Real)newValue);
				return;
			case FmiPackage.MODEL_DESCRIPTION__TYPE_DEFINITIONS:
				getTypeDefinitions().clear();
				getTypeDefinitions().addAll((Collection<? extends SimpleType>)newValue);
				return;
			case FmiPackage.MODEL_DESCRIPTION__UNIT_DEFINITIONS:
				getUnitDefinitions().clear();
				getUnitDefinitions().addAll((Collection<? extends Unit>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case FmiPackage.MODEL_DESCRIPTION__SEED:
				setSeed((com.inchron.realtime.root.model.fmi.variable.Integer)null);
				return;
			case FmiPackage.MODEL_DESCRIPTION__TIME:
				setTime((Real)null);
				return;
			case FmiPackage.MODEL_DESCRIPTION__TYPE_DEFINITIONS:
				unsetTypeDefinitions();
				return;
			case FmiPackage.MODEL_DESCRIPTION__UNIT_DEFINITIONS:
				unsetUnitDefinitions();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case FmiPackage.MODEL_DESCRIPTION__SEED:
				return seed != null;
			case FmiPackage.MODEL_DESCRIPTION__TIME:
				return time != null;
			case FmiPackage.MODEL_DESCRIPTION__TYPE_DEFINITIONS:
				return isSetTypeDefinitions();
			case FmiPackage.MODEL_DESCRIPTION__UNIT_DEFINITIONS:
				return isSetUnitDefinitions();
		}
		return super.eIsSet(featureID);
	}

} //ModelDescriptionImpl
