/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.unit;

import com.inchron.realtime.root.model.ModelObject;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Unit</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.Unit#getBaseUnit <em>Base Unit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.Unit#getDisplayUnits <em>Display Units</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getUnit()
 * @model
 * @generated
 */
public interface Unit extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Base Unit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Base Unit</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Base Unit</em>' containment reference.
	 * @see #setBaseUnit(BaseUnit)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getUnit_BaseUnit()
	 * @model containment="true"
	 * @generated
	 */
	BaseUnit getBaseUnit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.Unit#getBaseUnit <em>Base Unit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Base Unit</em>' containment reference.
	 * @see #getBaseUnit()
	 * @generated
	 */
	void setBaseUnit(BaseUnit value);

	/**
	 * Returns the value of the '<em><b>Display Units</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.fmi.unit.DisplayUnit}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Display Units</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Display Units</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getUnit_DisplayUnits()
	 * @model containment="true"
	 * @generated
	 */
	EList<DisplayUnit> getDisplayUnits();

} // Unit
