/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.unit.impl;

import com.inchron.realtime.root.model.fmi.unit.BaseUnit;
import com.inchron.realtime.root.model.fmi.unit.UnitPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Base Unit</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getA <em>A</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getCd <em>Cd</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getFactor <em>Factor</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getK <em>K</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getKg <em>Kg</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getM <em>M</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getMol <em>Mol</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getOffset <em>Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getRad <em>Rad</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.BaseUnitImpl#getS <em>S</em>}</li>
 * </ul>
 *
 * @generated
 */
public class BaseUnitImpl extends MinimalEObjectImpl.Container implements BaseUnit {
	/**
	 * The default value of the '{@link #getA() <em>A</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getA()
	 * @generated
	 * @ordered
	 */
	protected static final int A_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getA() <em>A</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getA()
	 * @generated
	 * @ordered
	 */
	protected int a = A_EDEFAULT;

	/**
	 * The default value of the '{@link #getCd() <em>Cd</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCd()
	 * @generated
	 * @ordered
	 */
	protected static final int CD_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getCd() <em>Cd</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCd()
	 * @generated
	 * @ordered
	 */
	protected int cd = CD_EDEFAULT;

	/**
	 * The default value of the '{@link #getFactor() <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactor()
	 * @generated
	 * @ordered
	 */
	protected static final double FACTOR_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getFactor() <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFactor()
	 * @generated
	 * @ordered
	 */
	protected double factor = FACTOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getK() <em>K</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getK()
	 * @generated
	 * @ordered
	 */
	protected static final int K_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getK() <em>K</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getK()
	 * @generated
	 * @ordered
	 */
	protected int k = K_EDEFAULT;

	/**
	 * The default value of the '{@link #getKg() <em>Kg</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKg()
	 * @generated
	 * @ordered
	 */
	protected static final int KG_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getKg() <em>Kg</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getKg()
	 * @generated
	 * @ordered
	 */
	protected int kg = KG_EDEFAULT;

	/**
	 * The default value of the '{@link #getM() <em>M</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getM()
	 * @generated
	 * @ordered
	 */
	protected static final int M_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getM() <em>M</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getM()
	 * @generated
	 * @ordered
	 */
	protected int m = M_EDEFAULT;

	/**
	 * The default value of the '{@link #getMol() <em>Mol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMol()
	 * @generated
	 * @ordered
	 */
	protected static final int MOL_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getMol() <em>Mol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMol()
	 * @generated
	 * @ordered
	 */
	protected int mol = MOL_EDEFAULT;

	/**
	 * The default value of the '{@link #getOffset() <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected static final double OFFSET_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getOffset() <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOffset()
	 * @generated
	 * @ordered
	 */
	protected double offset = OFFSET_EDEFAULT;

	/**
	 * The default value of the '{@link #getRad() <em>Rad</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRad()
	 * @generated
	 * @ordered
	 */
	protected static final int RAD_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getRad() <em>Rad</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRad()
	 * @generated
	 * @ordered
	 */
	protected int rad = RAD_EDEFAULT;

	/**
	 * The default value of the '{@link #getS() <em>S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getS()
	 * @generated
	 * @ordered
	 */
	protected static final int S_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getS() <em>S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getS()
	 * @generated
	 * @ordered
	 */
	protected int s = S_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BaseUnitImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UnitPackage.Literals.BASE_UNIT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getA() {
		return a;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setA(int newA) {
		int oldA = a;
		a = newA;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__A, oldA, a));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getCd() {
		return cd;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCd(int newCd) {
		int oldCd = cd;
		cd = newCd;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__CD, oldCd, cd));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getFactor() {
		return factor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFactor(double newFactor) {
		double oldFactor = factor;
		factor = newFactor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__FACTOR, oldFactor, factor));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getK() {
		return k;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setK(int newK) {
		int oldK = k;
		k = newK;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__K, oldK, k));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getKg() {
		return kg;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setKg(int newKg) {
		int oldKg = kg;
		kg = newKg;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__KG, oldKg, kg));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getM() {
		return m;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setM(int newM) {
		int oldM = m;
		m = newM;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__M, oldM, m));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMol() {
		return mol;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMol(int newMol) {
		int oldMol = mol;
		mol = newMol;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__MOL, oldMol, mol));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getOffset() {
		return offset;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOffset(double newOffset) {
		double oldOffset = offset;
		offset = newOffset;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__OFFSET, oldOffset, offset));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getRad() {
		return rad;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRad(int newRad) {
		int oldRad = rad;
		rad = newRad;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__RAD, oldRad, rad));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getS() {
		return s;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setS(int newS) {
		int oldS = s;
		s = newS;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.BASE_UNIT__S, oldS, s));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UnitPackage.BASE_UNIT__A:
				return getA();
			case UnitPackage.BASE_UNIT__CD:
				return getCd();
			case UnitPackage.BASE_UNIT__FACTOR:
				return getFactor();
			case UnitPackage.BASE_UNIT__K:
				return getK();
			case UnitPackage.BASE_UNIT__KG:
				return getKg();
			case UnitPackage.BASE_UNIT__M:
				return getM();
			case UnitPackage.BASE_UNIT__MOL:
				return getMol();
			case UnitPackage.BASE_UNIT__OFFSET:
				return getOffset();
			case UnitPackage.BASE_UNIT__RAD:
				return getRad();
			case UnitPackage.BASE_UNIT__S:
				return getS();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UnitPackage.BASE_UNIT__A:
				setA((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__CD:
				setCd((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__FACTOR:
				setFactor((Double)newValue);
				return;
			case UnitPackage.BASE_UNIT__K:
				setK((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__KG:
				setKg((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__M:
				setM((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__MOL:
				setMol((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__OFFSET:
				setOffset((Double)newValue);
				return;
			case UnitPackage.BASE_UNIT__RAD:
				setRad((Integer)newValue);
				return;
			case UnitPackage.BASE_UNIT__S:
				setS((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UnitPackage.BASE_UNIT__A:
				setA(A_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__CD:
				setCd(CD_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__FACTOR:
				setFactor(FACTOR_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__K:
				setK(K_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__KG:
				setKg(KG_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__M:
				setM(M_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__MOL:
				setMol(MOL_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__OFFSET:
				setOffset(OFFSET_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__RAD:
				setRad(RAD_EDEFAULT);
				return;
			case UnitPackage.BASE_UNIT__S:
				setS(S_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UnitPackage.BASE_UNIT__A:
				return a != A_EDEFAULT;
			case UnitPackage.BASE_UNIT__CD:
				return cd != CD_EDEFAULT;
			case UnitPackage.BASE_UNIT__FACTOR:
				return factor != FACTOR_EDEFAULT;
			case UnitPackage.BASE_UNIT__K:
				return k != K_EDEFAULT;
			case UnitPackage.BASE_UNIT__KG:
				return kg != KG_EDEFAULT;
			case UnitPackage.BASE_UNIT__M:
				return m != M_EDEFAULT;
			case UnitPackage.BASE_UNIT__MOL:
				return mol != MOL_EDEFAULT;
			case UnitPackage.BASE_UNIT__OFFSET:
				return offset != OFFSET_EDEFAULT;
			case UnitPackage.BASE_UNIT__RAD:
				return rad != RAD_EDEFAULT;
			case UnitPackage.BASE_UNIT__S:
				return s != S_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (a: ");
		result.append(a);
		result.append(", cd: ");
		result.append(cd);
		result.append(", factor: ");
		result.append(factor);
		result.append(", k: ");
		result.append(k);
		result.append(", kg: ");
		result.append(kg);
		result.append(", m: ");
		result.append(m);
		result.append(", mol: ");
		result.append(mol);
		result.append(", offset: ");
		result.append(offset);
		result.append(", rad: ");
		result.append(rad);
		result.append(", s: ");
		result.append(s);
		result.append(')');
		return result.toString();
	}

} //BaseUnitImpl
