/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.unit.impl;

import com.inchron.realtime.root.model.fmi.unit.BaseUnit;
import com.inchron.realtime.root.model.fmi.unit.DisplayUnit;
import com.inchron.realtime.root.model.fmi.unit.Unit;
import com.inchron.realtime.root.model.fmi.unit.UnitPackage;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Unit</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.UnitImpl#getBaseUnit <em>Base Unit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.impl.UnitImpl#getDisplayUnits <em>Display Units</em>}</li>
 * </ul>
 *
 * @generated
 */
public class UnitImpl extends ModelObjectImpl implements Unit {
	/**
	 * The cached value of the '{@link #getBaseUnit() <em>Base Unit</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBaseUnit()
	 * @generated
	 * @ordered
	 */
	protected BaseUnit baseUnit;

	/**
	 * The cached value of the '{@link #getDisplayUnits() <em>Display Units</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDisplayUnits()
	 * @generated
	 * @ordered
	 */
	protected EList<DisplayUnit> displayUnits;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected UnitImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UnitPackage.Literals.UNIT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BaseUnit getBaseUnit() {
		return baseUnit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBaseUnit(BaseUnit newBaseUnit, NotificationChain msgs) {
		BaseUnit oldBaseUnit = baseUnit;
		baseUnit = newBaseUnit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, UnitPackage.UNIT__BASE_UNIT, oldBaseUnit, newBaseUnit);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBaseUnit(BaseUnit newBaseUnit) {
		if (newBaseUnit != baseUnit) {
			NotificationChain msgs = null;
			if (baseUnit != null)
				msgs = ((InternalEObject)baseUnit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - UnitPackage.UNIT__BASE_UNIT, null, msgs);
			if (newBaseUnit != null)
				msgs = ((InternalEObject)newBaseUnit).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - UnitPackage.UNIT__BASE_UNIT, null, msgs);
			msgs = basicSetBaseUnit(newBaseUnit, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UnitPackage.UNIT__BASE_UNIT, newBaseUnit, newBaseUnit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DisplayUnit> getDisplayUnits() {
		if (displayUnits == null) {
			displayUnits = new EObjectContainmentEList<DisplayUnit>(DisplayUnit.class, this, UnitPackage.UNIT__DISPLAY_UNITS);
		}
		return displayUnits;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UnitPackage.UNIT__BASE_UNIT:
				return basicSetBaseUnit(null, msgs);
			case UnitPackage.UNIT__DISPLAY_UNITS:
				return ((InternalEList<?>)getDisplayUnits()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UnitPackage.UNIT__BASE_UNIT:
				return getBaseUnit();
			case UnitPackage.UNIT__DISPLAY_UNITS:
				return getDisplayUnits();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UnitPackage.UNIT__BASE_UNIT:
				setBaseUnit((BaseUnit)newValue);
				return;
			case UnitPackage.UNIT__DISPLAY_UNITS:
				getDisplayUnits().clear();
				getDisplayUnits().addAll((Collection<? extends DisplayUnit>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UnitPackage.UNIT__BASE_UNIT:
				setBaseUnit((BaseUnit)null);
				return;
			case UnitPackage.UNIT__DISPLAY_UNITS:
				getDisplayUnits().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UnitPackage.UNIT__BASE_UNIT:
				return baseUnit != null;
			case UnitPackage.UNIT__DISPLAY_UNITS:
				return displayUnits != null && !displayUnits.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //UnitImpl
