/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.variable.impl;

import com.inchron.realtime.root.RootPackage;
import com.inchron.realtime.root.impl.RootPackageImpl;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl;
import com.inchron.realtime.root.model.fmi.FmiPackage;
import com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl;
import com.inchron.realtime.root.model.fmi.type.TypePackage;
import com.inchron.realtime.root.model.fmi.type.impl.TypePackageImpl;
import com.inchron.realtime.root.model.fmi.unit.UnitPackage;
import com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl;
import com.inchron.realtime.root.model.fmi.variable.VariableFactory;
import com.inchron.realtime.root.model.fmi.variable.VariablePackage;
import com.inchron.realtime.root.model.impl.ModelPackageImpl;
import com.inchron.realtime.root.model.memory.MemoryPackage;
import com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;
import com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl;
import com.inchron.realtime.root.model.requirement.RequirementPackage;
import com.inchron.realtime.root.model.requirement.impl.RequirementPackageImpl;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;
import com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl;
import com.inchron.realtime.root.settings.SettingsPackage;
import com.inchron.realtime.root.settings.impl.SettingsPackageImpl;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class VariablePackageImpl extends EPackageImpl implements VariablePackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass booleanEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass enumerationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass integerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass realEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scalarVariableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum causalityEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum initialEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum triggerTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum variabilityEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.inchron.realtime.root.model.fmi.variable.VariablePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private VariablePackageImpl() {
		super(eNS_URI, VariableFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link VariablePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @generated
	 */
	public static VariablePackage init() {
		if (isInited) return (VariablePackage)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI);

		// Obtain or create and register package
		VariablePackageImpl theVariablePackage = (VariablePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof VariablePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new VariablePackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		RootPackageImpl theRootPackage = (RootPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) instanceof RootPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) : RootPackage.eINSTANCE);
		ModelPackageImpl theModelPackage = (ModelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) instanceof ModelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) : ModelPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		FmiPackageImpl theFmiPackage = (FmiPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) instanceof FmiPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) : FmiPackage.eINSTANCE);
		TypePackageImpl theTypePackage = (TypePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) instanceof TypePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) : TypePackage.eINSTANCE);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) instanceof UnitPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) : UnitPackage.eINSTANCE);
		MemoryPackageImpl theMemoryPackage = (MemoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) instanceof MemoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) : MemoryPackage.eINSTANCE);
		PeripheralPackageImpl thePeripheralPackage = (PeripheralPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI) instanceof PeripheralPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI) : PeripheralPackage.eINSTANCE);
		RequirementPackageImpl theRequirementPackage = (RequirementPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI) instanceof RequirementPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI) : RequirementPackage.eINSTANCE);
		StimulationPackageImpl theStimulationPackage = (StimulationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI) instanceof StimulationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI) : StimulationPackage.eINSTANCE);
		SettingsPackageImpl theSettingsPackage = (SettingsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) instanceof SettingsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) : SettingsPackage.eINSTANCE);

		// Load packages
		theRootPackage.loadPackage();

		// Fix loaded packages
		theVariablePackage.fixPackageContents();
		theRootPackage.fixPackageContents();
		theModelPackage.fixPackageContents();
		theAutosarPackage.fixPackageContents();
		theFmiPackage.fixPackageContents();
		theTypePackage.fixPackageContents();
		theUnitPackage.fixPackageContents();
		theMemoryPackage.fixPackageContents();
		thePeripheralPackage.fixPackageContents();
		theRequirementPackage.fixPackageContents();
		theStimulationPackage.fixPackageContents();
		theSettingsPackage.fixPackageContents();

		// Mark meta-data to indicate it can't be changed
		theVariablePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(VariablePackage.eNS_URI, theVariablePackage);
		return theVariablePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBoolean() {
		if (booleanEClass == null) {
			booleanEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(0);
		}
		return booleanEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBoolean_DeclaredType() {
        return (EReference)getBoolean().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBoolean_Start() {
        return (EAttribute)getBoolean().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEnumeration() {
		if (enumerationEClass == null) {
			enumerationEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(2);
		}
		return enumerationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEnumeration_DeclaredType() {
        return (EReference)getEnumeration().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEnumeration_Max() {
        return (EAttribute)getEnumeration().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEnumeration_Min() {
        return (EAttribute)getEnumeration().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEnumeration_Quantity() {
        return (EAttribute)getEnumeration().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEnumeration_Start() {
        return (EAttribute)getEnumeration().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInteger() {
		if (integerEClass == null) {
			integerEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(4);
		}
		return integerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInteger_DeclaredType() {
        return (EReference)getInteger().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInteger_Start() {
        return (EAttribute)getInteger().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getReal() {
		if (realEClass == null) {
			realEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(5);
		}
		return realEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getReal_DeclaredType() {
        return (EReference)getReal().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getReal_Start() {
        return (EAttribute)getReal().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScalarVariable() {
		if (scalarVariableEClass == null) {
			scalarVariableEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(6);
		}
		return scalarVariableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScalarVariable_CallGraph() {
        return (EReference)getScalarVariable().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalarVariable_Causality() {
        return (EAttribute)getScalarVariable().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScalarVariable_Connections() {
        return (EReference)getScalarVariable().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalarVariable_Description() {
        return (EAttribute)getScalarVariable().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalarVariable_Initial() {
        return (EAttribute)getScalarVariable().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalarVariable_TriggerType() {
        return (EAttribute)getScalarVariable().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalarVariable_ValueReference() {
        return (EAttribute)getScalarVariable().getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScalarVariable_Variability() {
        return (EAttribute)getScalarVariable().getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getCausality() {
		if (causalityEEnum == null) {
			causalityEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(1);
		}
		return causalityEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getInitial() {
		if (initialEEnum == null) {
			initialEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(3);
		}
		return initialEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTriggerType() {
		if (triggerTypeEEnum == null) {
			triggerTypeEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(7);
		}
		return triggerTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getVariability() {
		if (variabilityEEnum == null) {
			variabilityEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI).getEClassifiers().get(8);
		}
		return variabilityEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableFactory getVariableFactory() {
		return (VariableFactory)getEFactoryInstance();
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isFixed = false;

	/**
	 * Fixes up the loaded package, to make it appear as if it had been programmatically built.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fixPackageContents() {
		if (isFixed) return;
		isFixed = true;
		fixEClassifiers();
	}

	/**
	 * Sets the instance class on the given classifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void fixInstanceClass(EClassifier eClassifier) {
		if (eClassifier.getInstanceClassName() == null) {
			eClassifier.setInstanceClassName("com.inchron.realtime.root.model.fmi.variable." + eClassifier.getName());
			setGeneratedClassName(eClassifier);
		}
	}

} //VariablePackageImpl
