/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.BusMessage;
import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.MessageData;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TraceEvent;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Bus Message</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.BusMessageImpl#getFullMessages <em>Full Messages</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.BusMessageImpl#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.BusMessageImpl#getInCallGraph <em>In Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.BusMessageImpl#getOutCallGraph <em>Out Call Graph</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class BusMessageImpl extends ModelObjectImpl implements BusMessage {
	/**
	 * The cached value of the '{@link #getFullMessages() <em>Full Messages</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFullMessages()
	 * @generated
	 * @ordered
	 */
	protected EList<MessageData> fullMessages;

	/**
	 * The cached value of the '{@link #getEvents() <em>Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<TraceEvent> events;

	/**
	 * The cached value of the '{@link #getInCallGraph() <em>In Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInCallGraph()
	 * @generated
	 * @ordered
	 */
	protected CallGraph inCallGraph;

	/**
	 * The cached value of the '{@link #getOutCallGraph() <em>Out Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutCallGraph()
	 * @generated
	 * @ordered
	 */
	protected CallGraph outCallGraph;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BusMessageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getBusMessage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<MessageData> getFullMessages() {
		if (fullMessages == null) {
			fullMessages = new EObjectContainmentEList<MessageData>(MessageData.class, this, ModelPackage.BUS_MESSAGE__FULL_MESSAGES);
		}
		return fullMessages;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TraceEvent> getEvents() {
		if (events == null) {
			events = new EObjectContainmentEList<TraceEvent>(TraceEvent.class, this, ModelPackage.BUS_MESSAGE__EVENTS);
		}
		return events;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallGraph getInCallGraph() {
		return inCallGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInCallGraph(CallGraph newInCallGraph, NotificationChain msgs) {
		CallGraph oldInCallGraph = inCallGraph;
		inCallGraph = newInCallGraph;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH, oldInCallGraph, newInCallGraph);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInCallGraph(CallGraph newInCallGraph) {
		if (newInCallGraph != inCallGraph) {
			NotificationChain msgs = null;
			if (inCallGraph != null)
				msgs = ((InternalEObject)inCallGraph).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH, null, msgs);
			if (newInCallGraph != null)
				msgs = ((InternalEObject)newInCallGraph).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH, null, msgs);
			msgs = basicSetInCallGraph(newInCallGraph, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH, newInCallGraph, newInCallGraph));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallGraph getOutCallGraph() {
		return outCallGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOutCallGraph(CallGraph newOutCallGraph, NotificationChain msgs) {
		CallGraph oldOutCallGraph = outCallGraph;
		outCallGraph = newOutCallGraph;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH, oldOutCallGraph, newOutCallGraph);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOutCallGraph(CallGraph newOutCallGraph) {
		if (newOutCallGraph != outCallGraph) {
			NotificationChain msgs = null;
			if (outCallGraph != null)
				msgs = ((InternalEObject)outCallGraph).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH, null, msgs);
			if (newOutCallGraph != null)
				msgs = ((InternalEObject)newOutCallGraph).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH, null, msgs);
			msgs = basicSetOutCallGraph(newOutCallGraph, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH, newOutCallGraph, newOutCallGraph));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.BUS_MESSAGE__FULL_MESSAGES:
				return ((InternalEList<?>)getFullMessages()).basicRemove(otherEnd, msgs);
			case ModelPackage.BUS_MESSAGE__EVENTS:
				return ((InternalEList<?>)getEvents()).basicRemove(otherEnd, msgs);
			case ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH:
				return basicSetInCallGraph(null, msgs);
			case ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH:
				return basicSetOutCallGraph(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.BUS_MESSAGE__FULL_MESSAGES:
				return getFullMessages();
			case ModelPackage.BUS_MESSAGE__EVENTS:
				return getEvents();
			case ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH:
				return getInCallGraph();
			case ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH:
				return getOutCallGraph();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.BUS_MESSAGE__FULL_MESSAGES:
				getFullMessages().clear();
				getFullMessages().addAll((Collection<? extends MessageData>)newValue);
				return;
			case ModelPackage.BUS_MESSAGE__EVENTS:
				getEvents().clear();
				getEvents().addAll((Collection<? extends TraceEvent>)newValue);
				return;
			case ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH:
				setInCallGraph((CallGraph)newValue);
				return;
			case ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH:
				setOutCallGraph((CallGraph)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.BUS_MESSAGE__FULL_MESSAGES:
				getFullMessages().clear();
				return;
			case ModelPackage.BUS_MESSAGE__EVENTS:
				getEvents().clear();
				return;
			case ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH:
				setInCallGraph((CallGraph)null);
				return;
			case ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH:
				setOutCallGraph((CallGraph)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.BUS_MESSAGE__FULL_MESSAGES:
				return fullMessages != null && !fullMessages.isEmpty();
			case ModelPackage.BUS_MESSAGE__EVENTS:
				return events != null && !events.isEmpty();
			case ModelPackage.BUS_MESSAGE__IN_CALL_GRAPH:
				return inCallGraph != null;
			case ModelPackage.BUS_MESSAGE__OUT_CALL_GRAPH:
				return outCallGraph != null;
		}
		return super.eIsSet(featureID);
	}

} //BusMessageImpl
