/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.Component;
import com.inchron.realtime.root.model.Function;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TranslationUnit;

import com.inchron.realtime.root.model.memory.DataObject;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ComponentImpl#getVariables <em>Variables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ComponentImpl#getFunctions <em>Functions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ComponentImpl#getTranslationUnits <em>Translation Units</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ComponentImpl extends ModelObjectImpl implements Component {
	/**
	 * The cached value of the '{@link #getVariables() <em>Variables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVariables()
	 * @generated
	 * @ordered
	 */
	protected EList<DataObject> variables;

	/**
	 * The cached value of the '{@link #getFunctions() <em>Functions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFunctions()
	 * @generated
	 * @ordered
	 */
	protected EList<Function> functions;

	/**
	 * The cached value of the '{@link #getTranslationUnits() <em>Translation Units</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTranslationUnits()
	 * @generated
	 * @ordered
	 */
	protected EList<TranslationUnit> translationUnits;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getComponent();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<DataObject> getVariables() {
		if (variables == null) {
			variables = new EObjectContainmentEList<DataObject>(DataObject.class, this, ModelPackage.COMPONENT__VARIABLES);
		}
		return variables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Function> getFunctions() {
		if (functions == null) {
			functions = new EObjectContainmentEList<Function>(Function.class, this, ModelPackage.COMPONENT__FUNCTIONS);
		}
		return functions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TranslationUnit> getTranslationUnits() {
		if (translationUnits == null) {
			translationUnits = new EObjectResolvingEList<TranslationUnit>(TranslationUnit.class, this, ModelPackage.COMPONENT__TRANSLATION_UNITS);
		}
		return translationUnits;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.COMPONENT__VARIABLES:
				return ((InternalEList<?>)getVariables()).basicRemove(otherEnd, msgs);
			case ModelPackage.COMPONENT__FUNCTIONS:
				return ((InternalEList<?>)getFunctions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.COMPONENT__VARIABLES:
				return getVariables();
			case ModelPackage.COMPONENT__FUNCTIONS:
				return getFunctions();
			case ModelPackage.COMPONENT__TRANSLATION_UNITS:
				return getTranslationUnits();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.COMPONENT__VARIABLES:
				getVariables().clear();
				getVariables().addAll((Collection<? extends DataObject>)newValue);
				return;
			case ModelPackage.COMPONENT__FUNCTIONS:
				getFunctions().clear();
				getFunctions().addAll((Collection<? extends Function>)newValue);
				return;
			case ModelPackage.COMPONENT__TRANSLATION_UNITS:
				getTranslationUnits().clear();
				getTranslationUnits().addAll((Collection<? extends TranslationUnit>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.COMPONENT__VARIABLES:
				getVariables().clear();
				return;
			case ModelPackage.COMPONENT__FUNCTIONS:
				getFunctions().clear();
				return;
			case ModelPackage.COMPONENT__TRANSLATION_UNITS:
				getTranslationUnits().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.COMPONENT__VARIABLES:
				return variables != null && !variables.isEmpty();
			case ModelPackage.COMPONENT__FUNCTIONS:
				return functions != null && !functions.isEmpty();
			case ModelPackage.COMPONENT__TRANSLATION_UNITS:
				return translationUnits != null && !translationUnits.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //ComponentImpl
