/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.HyperVisorVirtualCoreSchedulable;
import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Hyper Visor Virtual Core Schedulable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.HyperVisorVirtualCoreSchedulableImpl#getVirtualCore <em>Virtual Core</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HyperVisorVirtualCoreSchedulableImpl extends SchedulableImpl implements HyperVisorVirtualCoreSchedulable {
	/**
	 * The cached value of the '{@link #getVirtualCore() <em>Virtual Core</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVirtualCore()
	 * @generated
	 * @ordered
	 */
	protected CpuCore virtualCore;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HyperVisorVirtualCoreSchedulableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getHyperVisorVirtualCoreSchedulable();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CpuCore getVirtualCore() {
		if (virtualCore != null && virtualCore.eIsProxy()) {
			InternalEObject oldVirtualCore = (InternalEObject)virtualCore;
			virtualCore = (CpuCore)eResolveProxy(oldVirtualCore);
			if (virtualCore != oldVirtualCore) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE, oldVirtualCore, virtualCore));
			}
		}
		return virtualCore;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CpuCore basicGetVirtualCore() {
		return virtualCore;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVirtualCore(CpuCore newVirtualCore) {
		CpuCore oldVirtualCore = virtualCore;
		virtualCore = newVirtualCore;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE, oldVirtualCore, virtualCore));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE:
				if (resolve) return getVirtualCore();
				return basicGetVirtualCore();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE:
				setVirtualCore((CpuCore)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE:
				setVirtualCore((CpuCore)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE:
				return virtualCore != null;
		}
		return super.eIsSet(featureID);
	}

} //HyperVisorVirtualCoreSchedulableImpl
