/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CallGraph;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Time;
import com.inchron.realtime.root.model.TraceEvent;

import com.inchron.realtime.root.model.peripheral.InterruptPort;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Process</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#getActivationLimit <em>Activation Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#isActiveAtBoot <em>Active At Boot</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#getCallGraph <em>Call Graph</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#getDeadline <em>Deadline</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#isExtendedTask <em>Extended Task</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#getTraceEvents <em>Trace Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#isIdleTask <em>Idle Task</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#isIsr <em>Isr</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#isPreemptable <em>Preemptable</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#getStackLimit <em>Stack Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ProcessImpl#getTriggeringPort <em>Triggering Port</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ProcessImpl extends SchedulableImpl implements com.inchron.realtime.root.model.Process {
	/**
	 * The default value of the '{@link #getActivationLimit() <em>Activation Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivationLimit()
	 * @generated
	 * @ordered
	 */
	protected static final int ACTIVATION_LIMIT_EDEFAULT = 1;

	/**
	 * The cached value of the '{@link #getActivationLimit() <em>Activation Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivationLimit()
	 * @generated
	 * @ordered
	 */
	protected int activationLimit = ACTIVATION_LIMIT_EDEFAULT;

	/**
	 * The default value of the '{@link #isActiveAtBoot() <em>Active At Boot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isActiveAtBoot()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ACTIVE_AT_BOOT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isActiveAtBoot() <em>Active At Boot</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isActiveAtBoot()
	 * @generated
	 * @ordered
	 */
	protected boolean activeAtBoot = ACTIVE_AT_BOOT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCallGraph() <em>Call Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCallGraph()
	 * @generated
	 * @ordered
	 */
	protected CallGraph callGraph;

	/**
	 * The cached value of the '{@link #getDeadline() <em>Deadline</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDeadline()
	 * @generated
	 * @ordered
	 */
	protected Time deadline;

	/**
	 * The default value of the '{@link #isExtendedTask() <em>Extended Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isExtendedTask()
	 * @generated
	 * @ordered
	 */
	protected static final boolean EXTENDED_TASK_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isExtendedTask() <em>Extended Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isExtendedTask()
	 * @generated
	 * @ordered
	 */
	protected boolean extendedTask = EXTENDED_TASK_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTraceEvents() <em>Trace Events</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTraceEvents()
	 * @generated
	 * @ordered
	 */
	protected EList<TraceEvent> traceEvents;

	/**
	 * The default value of the '{@link #isIdleTask() <em>Idle Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIdleTask()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IDLE_TASK_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIdleTask() <em>Idle Task</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIdleTask()
	 * @generated
	 * @ordered
	 */
	protected boolean idleTask = IDLE_TASK_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsr() <em>Isr</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsr()
	 * @generated
	 * @ordered
	 */
	protected static final boolean ISR_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsr() <em>Isr</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsr()
	 * @generated
	 * @ordered
	 */
	protected boolean isr = ISR_EDEFAULT;

	/**
	 * The default value of the '{@link #isPreemptable() <em>Preemptable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPreemptable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PREEMPTABLE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isPreemptable() <em>Preemptable</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPreemptable()
	 * @generated
	 * @ordered
	 */
	protected boolean preemptable = PREEMPTABLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getStackLimit() <em>Stack Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStackLimit()
	 * @generated
	 * @ordered
	 */
	protected static final int STACK_LIMIT_EDEFAULT = 1024;

	/**
	 * The cached value of the '{@link #getStackLimit() <em>Stack Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStackLimit()
	 * @generated
	 * @ordered
	 */
	protected int stackLimit = STACK_LIMIT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTriggeringPort() <em>Triggering Port</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggeringPort()
	 * @generated
	 * @ordered
	 */
	protected EList<InterruptPort> triggeringPort;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getProcess();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getActivationLimit() {
		return activationLimit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActivationLimit(int newActivationLimit) {
		int oldActivationLimit = activationLimit;
		activationLimit = newActivationLimit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__ACTIVATION_LIMIT, oldActivationLimit, activationLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isActiveAtBoot() {
		return activeAtBoot;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setActiveAtBoot(boolean newActiveAtBoot) {
		boolean oldActiveAtBoot = activeAtBoot;
		activeAtBoot = newActiveAtBoot;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__ACTIVE_AT_BOOT, oldActiveAtBoot, activeAtBoot));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallGraph getCallGraph() {
		return callGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCallGraph(CallGraph newCallGraph, NotificationChain msgs) {
		CallGraph oldCallGraph = callGraph;
		callGraph = newCallGraph;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__CALL_GRAPH, oldCallGraph, newCallGraph);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCallGraph(CallGraph newCallGraph) {
		if (newCallGraph != callGraph) {
			NotificationChain msgs = null;
			if (callGraph != null)
				msgs = ((InternalEObject)callGraph).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.PROCESS__CALL_GRAPH, null, msgs);
			if (newCallGraph != null)
				msgs = ((InternalEObject)newCallGraph).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.PROCESS__CALL_GRAPH, null, msgs);
			msgs = basicSetCallGraph(newCallGraph, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__CALL_GRAPH, newCallGraph, newCallGraph));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getDeadline() {
		return deadline;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDeadline(Time newDeadline, NotificationChain msgs) {
		Time oldDeadline = deadline;
		deadline = newDeadline;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__DEADLINE, oldDeadline, newDeadline);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeadline(Time newDeadline) {
		if (newDeadline != deadline) {
			NotificationChain msgs = null;
			if (deadline != null)
				msgs = ((InternalEObject)deadline).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.PROCESS__DEADLINE, null, msgs);
			if (newDeadline != null)
				msgs = ((InternalEObject)newDeadline).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.PROCESS__DEADLINE, null, msgs);
			msgs = basicSetDeadline(newDeadline, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__DEADLINE, newDeadline, newDeadline));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isExtendedTask() {
		return extendedTask;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExtendedTask(boolean newExtendedTask) {
		boolean oldExtendedTask = extendedTask;
		extendedTask = newExtendedTask;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__EXTENDED_TASK, oldExtendedTask, extendedTask));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TraceEvent> getTraceEvents() {
		if (traceEvents == null) {
			traceEvents = new EObjectContainmentEList<TraceEvent>(TraceEvent.class, this, ModelPackage.PROCESS__TRACE_EVENTS);
		}
		return traceEvents;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIdleTask() {
		return idleTask;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIdleTask(boolean newIdleTask) {
		boolean oldIdleTask = idleTask;
		idleTask = newIdleTask;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__IDLE_TASK, oldIdleTask, idleTask));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsr() {
		return isr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsr(boolean newIsr) {
		boolean oldIsr = isr;
		isr = newIsr;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__ISR, oldIsr, isr));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPreemptable() {
		return preemptable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPreemptable(boolean newPreemptable) {
		boolean oldPreemptable = preemptable;
		preemptable = newPreemptable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__PREEMPTABLE, oldPreemptable, preemptable));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getStackLimit() {
		return stackLimit;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStackLimit(int newStackLimit) {
		int oldStackLimit = stackLimit;
		stackLimit = newStackLimit;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.PROCESS__STACK_LIMIT, oldStackLimit, stackLimit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InterruptPort> getTriggeringPort() {
		if (triggeringPort == null) {
			triggeringPort = new EObjectWithInverseResolvingEList.ManyInverse<InterruptPort>(InterruptPort.class, this, ModelPackage.PROCESS__TRIGGERING_PORT, PeripheralPackage.INTERRUPT_PORT__ISRS);
		}
		return triggeringPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.PROCESS__TRIGGERING_PORT:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getTriggeringPort()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.PROCESS__CALL_GRAPH:
				return basicSetCallGraph(null, msgs);
			case ModelPackage.PROCESS__DEADLINE:
				return basicSetDeadline(null, msgs);
			case ModelPackage.PROCESS__TRACE_EVENTS:
				return ((InternalEList<?>)getTraceEvents()).basicRemove(otherEnd, msgs);
			case ModelPackage.PROCESS__TRIGGERING_PORT:
				return ((InternalEList<?>)getTriggeringPort()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.PROCESS__ACTIVATION_LIMIT:
				return getActivationLimit();
			case ModelPackage.PROCESS__ACTIVE_AT_BOOT:
				return isActiveAtBoot();
			case ModelPackage.PROCESS__CALL_GRAPH:
				return getCallGraph();
			case ModelPackage.PROCESS__DEADLINE:
				return getDeadline();
			case ModelPackage.PROCESS__EXTENDED_TASK:
				return isExtendedTask();
			case ModelPackage.PROCESS__TRACE_EVENTS:
				return getTraceEvents();
			case ModelPackage.PROCESS__IDLE_TASK:
				return isIdleTask();
			case ModelPackage.PROCESS__ISR:
				return isIsr();
			case ModelPackage.PROCESS__PREEMPTABLE:
				return isPreemptable();
			case ModelPackage.PROCESS__STACK_LIMIT:
				return getStackLimit();
			case ModelPackage.PROCESS__TRIGGERING_PORT:
				return getTriggeringPort();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.PROCESS__ACTIVATION_LIMIT:
				setActivationLimit((Integer)newValue);
				return;
			case ModelPackage.PROCESS__ACTIVE_AT_BOOT:
				setActiveAtBoot((Boolean)newValue);
				return;
			case ModelPackage.PROCESS__CALL_GRAPH:
				setCallGraph((CallGraph)newValue);
				return;
			case ModelPackage.PROCESS__DEADLINE:
				setDeadline((Time)newValue);
				return;
			case ModelPackage.PROCESS__EXTENDED_TASK:
				setExtendedTask((Boolean)newValue);
				return;
			case ModelPackage.PROCESS__TRACE_EVENTS:
				getTraceEvents().clear();
				getTraceEvents().addAll((Collection<? extends TraceEvent>)newValue);
				return;
			case ModelPackage.PROCESS__IDLE_TASK:
				setIdleTask((Boolean)newValue);
				return;
			case ModelPackage.PROCESS__ISR:
				setIsr((Boolean)newValue);
				return;
			case ModelPackage.PROCESS__PREEMPTABLE:
				setPreemptable((Boolean)newValue);
				return;
			case ModelPackage.PROCESS__STACK_LIMIT:
				setStackLimit((Integer)newValue);
				return;
			case ModelPackage.PROCESS__TRIGGERING_PORT:
				getTriggeringPort().clear();
				getTriggeringPort().addAll((Collection<? extends InterruptPort>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.PROCESS__ACTIVATION_LIMIT:
				setActivationLimit(ACTIVATION_LIMIT_EDEFAULT);
				return;
			case ModelPackage.PROCESS__ACTIVE_AT_BOOT:
				setActiveAtBoot(ACTIVE_AT_BOOT_EDEFAULT);
				return;
			case ModelPackage.PROCESS__CALL_GRAPH:
				setCallGraph((CallGraph)null);
				return;
			case ModelPackage.PROCESS__DEADLINE:
				setDeadline((Time)null);
				return;
			case ModelPackage.PROCESS__EXTENDED_TASK:
				setExtendedTask(EXTENDED_TASK_EDEFAULT);
				return;
			case ModelPackage.PROCESS__TRACE_EVENTS:
				getTraceEvents().clear();
				return;
			case ModelPackage.PROCESS__IDLE_TASK:
				setIdleTask(IDLE_TASK_EDEFAULT);
				return;
			case ModelPackage.PROCESS__ISR:
				setIsr(ISR_EDEFAULT);
				return;
			case ModelPackage.PROCESS__PREEMPTABLE:
				setPreemptable(PREEMPTABLE_EDEFAULT);
				return;
			case ModelPackage.PROCESS__STACK_LIMIT:
				setStackLimit(STACK_LIMIT_EDEFAULT);
				return;
			case ModelPackage.PROCESS__TRIGGERING_PORT:
				getTriggeringPort().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.PROCESS__ACTIVATION_LIMIT:
				return activationLimit != ACTIVATION_LIMIT_EDEFAULT;
			case ModelPackage.PROCESS__ACTIVE_AT_BOOT:
				return activeAtBoot != ACTIVE_AT_BOOT_EDEFAULT;
			case ModelPackage.PROCESS__CALL_GRAPH:
				return callGraph != null;
			case ModelPackage.PROCESS__DEADLINE:
				return deadline != null;
			case ModelPackage.PROCESS__EXTENDED_TASK:
				return extendedTask != EXTENDED_TASK_EDEFAULT;
			case ModelPackage.PROCESS__TRACE_EVENTS:
				return traceEvents != null && !traceEvents.isEmpty();
			case ModelPackage.PROCESS__IDLE_TASK:
				return idleTask != IDLE_TASK_EDEFAULT;
			case ModelPackage.PROCESS__ISR:
				return isr != ISR_EDEFAULT;
			case ModelPackage.PROCESS__PREEMPTABLE:
				return preemptable != PREEMPTABLE_EDEFAULT;
			case ModelPackage.PROCESS__STACK_LIMIT:
				return stackLimit != STACK_LIMIT_EDEFAULT;
			case ModelPackage.PROCESS__TRIGGERING_PORT:
				return triggeringPort != null && !triggeringPort.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (activationLimit: ");
		result.append(activationLimit);
		result.append(", activeAtBoot: ");
		result.append(activeAtBoot);
		result.append(", extendedTask: ");
		result.append(extendedTask);
		result.append(", idleTask: ");
		result.append(idleTask);
		result.append(", isr: ");
		result.append(isr);
		result.append(", preemptable: ");
		result.append(preemptable);
		result.append(", stackLimit: ");
		result.append(stackLimit);
		result.append(')');
		return result.toString();
	}

} //ProcessImpl
