/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Schedulable;
import com.inchron.realtime.root.model.TraceObject;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Schedulable</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulableImpl#getObjectId <em>Object Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulableImpl#getCpuCores <em>Cpu Cores</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulableImpl#getPriority <em>Priority</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class SchedulableImpl extends ModelObjectImpl implements Schedulable {
	/**
	 * The default value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected static final int OBJECT_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getObjectId() <em>Object Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObjectId()
	 * @generated
	 * @ordered
	 */
	protected int objectId = OBJECT_ID_EDEFAULT;

	/**
	 * This is true if the Object Id attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean objectIdESet;

	/**
	 * The cached value of the '{@link #getCpuCores() <em>Cpu Cores</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCpuCores()
	 * @generated
	 * @ordered
	 */
	protected EList<CpuCore> cpuCores;

	/**
	 * The default value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected static final int PRIORITY_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected int priority = PRIORITY_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SchedulableImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getSchedulable();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getObjectId() {
		return objectId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setObjectId(int newObjectId) {
		int oldObjectId = objectId;
		objectId = newObjectId;
		boolean oldObjectIdESet = objectIdESet;
		objectIdESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULABLE__OBJECT_ID, oldObjectId, objectId, !oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetObjectId() {
		int oldObjectId = objectId;
		boolean oldObjectIdESet = objectIdESet;
		objectId = OBJECT_ID_EDEFAULT;
		objectIdESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ModelPackage.SCHEDULABLE__OBJECT_ID, oldObjectId, OBJECT_ID_EDEFAULT, oldObjectIdESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetObjectId() {
		return objectIdESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CpuCore> getCpuCores() {
		if (cpuCores == null) {
			cpuCores = new EObjectResolvingEList<CpuCore>(CpuCore.class, this, ModelPackage.SCHEDULABLE__CPU_CORES);
		}
		return cpuCores;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPriority() {
		return priority;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPriority(int newPriority) {
		int oldPriority = priority;
		priority = newPriority;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULABLE__PRIORITY, oldPriority, priority));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SCHEDULABLE__OBJECT_ID:
				return getObjectId();
			case ModelPackage.SCHEDULABLE__CPU_CORES:
				return getCpuCores();
			case ModelPackage.SCHEDULABLE__PRIORITY:
				return getPriority();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SCHEDULABLE__OBJECT_ID:
				setObjectId((Integer)newValue);
				return;
			case ModelPackage.SCHEDULABLE__CPU_CORES:
				getCpuCores().clear();
				getCpuCores().addAll((Collection<? extends CpuCore>)newValue);
				return;
			case ModelPackage.SCHEDULABLE__PRIORITY:
				setPriority((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SCHEDULABLE__OBJECT_ID:
				unsetObjectId();
				return;
			case ModelPackage.SCHEDULABLE__CPU_CORES:
				getCpuCores().clear();
				return;
			case ModelPackage.SCHEDULABLE__PRIORITY:
				setPriority(PRIORITY_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SCHEDULABLE__OBJECT_ID:
				return isSetObjectId();
			case ModelPackage.SCHEDULABLE__CPU_CORES:
				return cpuCores != null && !cpuCores.isEmpty();
			case ModelPackage.SCHEDULABLE__PRIORITY:
				return priority != PRIORITY_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (derivedFeatureID) {
				case ModelPackage.SCHEDULABLE__OBJECT_ID: return ModelPackage.TRACE_OBJECT__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == TraceObject.class) {
			switch (baseFeatureID) {
				case ModelPackage.TRACE_OBJECT__OBJECT_ID: return ModelPackage.SCHEDULABLE__OBJECT_ID;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (objectId: ");
		if (objectIdESet) result.append(objectId); else result.append("<unset>");
		result.append(", priority: ");
		result.append(priority);
		result.append(')');
		return result.toString();
	}

} //SchedulableImpl
