/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CallbackFunction;
import com.inchron.realtime.root.model.CpuCore;
import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Schedulable;
import com.inchron.realtime.root.model.Scheduler;
import com.inchron.realtime.root.model.SchedulerStrategy;
import com.inchron.realtime.root.model.SchedulerType;
import com.inchron.realtime.root.model.SchedulingEntry;
import com.inchron.realtime.root.model.Time;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scheduler</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getSchedulables <em>Schedulables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getStrategy <em>Strategy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getTimeSlice <em>Time Slice</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getTdmaSchedule <em>Tdma Schedule</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#isSynchronized <em>Synchronized</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getMaxRetard <em>Max Retard</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getMaxAdvance <em>Max Advance</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getSyncSource <em>Sync Source</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getCycleStartProcess <em>Cycle Start Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#isPrioritiesPropagated <em>Priorities Propagated</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#isPriorityInversed <em>Priority Inversed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getCallbacks <em>Callbacks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulerImpl#getCallbackCoreAffinity <em>Callback Core Affinity</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SchedulerImpl extends SchedulableImpl implements Scheduler {
	/**
	 * The cached value of the '{@link #getSchedulables() <em>Schedulables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSchedulables()
	 * @generated
	 * @ordered
	 */
	protected EList<Schedulable> schedulables;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final SchedulerType TYPE_EDEFAULT = SchedulerType.PREEMPTIVE;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected SchedulerType type = TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #getStrategy() <em>Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStrategy()
	 * @generated
	 * @ordered
	 */
	protected static final SchedulerStrategy STRATEGY_EDEFAULT = SchedulerStrategy.FIXED_PRIORITY;

	/**
	 * The cached value of the '{@link #getStrategy() <em>Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStrategy()
	 * @generated
	 * @ordered
	 */
	protected SchedulerStrategy strategy = STRATEGY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTimeSlice() <em>Time Slice</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeSlice()
	 * @generated
	 * @ordered
	 */
	protected Time timeSlice;

	/**
	 * The cached value of the '{@link #getTdmaSchedule() <em>Tdma Schedule</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTdmaSchedule()
	 * @generated
	 * @ordered
	 */
	protected EList<SchedulingEntry> tdmaSchedule;

	/**
	 * The cached value of the '{@link #getPeriod() <em>Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPeriod()
	 * @generated
	 * @ordered
	 */
	protected Time period;

	/**
	 * The default value of the '{@link #isSynchronized() <em>Synchronized</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSynchronized()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SYNCHRONIZED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isSynchronized() <em>Synchronized</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSynchronized()
	 * @generated
	 * @ordered
	 */
	protected boolean synchronized_ = SYNCHRONIZED_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMaxRetard() <em>Max Retard</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxRetard()
	 * @generated
	 * @ordered
	 */
	protected Time maxRetard;

	/**
	 * The cached value of the '{@link #getMaxAdvance() <em>Max Advance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxAdvance()
	 * @generated
	 * @ordered
	 */
	protected Time maxAdvance;

	/**
	 * The cached value of the '{@link #getSyncSource() <em>Sync Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSyncSource()
	 * @generated
	 * @ordered
	 */
	protected ModelObject syncSource;

	/**
	 * The cached value of the '{@link #getCycleStartProcess() <em>Cycle Start Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCycleStartProcess()
	 * @generated
	 * @ordered
	 */
	protected com.inchron.realtime.root.model.Process cycleStartProcess;

	/**
	 * The default value of the '{@link #isPrioritiesPropagated() <em>Priorities Propagated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPrioritiesPropagated()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PRIORITIES_PROPAGATED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPrioritiesPropagated() <em>Priorities Propagated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPrioritiesPropagated()
	 * @generated
	 * @ordered
	 */
	protected boolean prioritiesPropagated = PRIORITIES_PROPAGATED_EDEFAULT;

	/**
	 * The default value of the '{@link #isPriorityInversed() <em>Priority Inversed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPriorityInversed()
	 * @generated
	 * @ordered
	 */
	protected static final boolean PRIORITY_INVERSED_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isPriorityInversed() <em>Priority Inversed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isPriorityInversed()
	 * @generated
	 * @ordered
	 */
	protected boolean priorityInversed = PRIORITY_INVERSED_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCallbacks() <em>Callbacks</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCallbacks()
	 * @generated
	 * @ordered
	 */
	protected EList<CallbackFunction> callbacks;

	/**
	 * The cached value of the '{@link #getCallbackCoreAffinity() <em>Callback Core Affinity</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCallbackCoreAffinity()
	 * @generated
	 * @ordered
	 */
	protected EList<CpuCore> callbackCoreAffinity;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SchedulerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getScheduler();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Schedulable> getSchedulables() {
		if (schedulables == null) {
			schedulables = new EObjectContainmentEList<Schedulable>(Schedulable.class, this, ModelPackage.SCHEDULER__SCHEDULABLES);
		}
		return schedulables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SchedulerType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(SchedulerType newType) {
		SchedulerType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SchedulerStrategy getStrategy() {
		return strategy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStrategy(SchedulerStrategy newStrategy) {
		SchedulerStrategy oldStrategy = strategy;
		strategy = newStrategy == null ? STRATEGY_EDEFAULT : newStrategy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__STRATEGY, oldStrategy, strategy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getTimeSlice() {
		return timeSlice;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTimeSlice(Time newTimeSlice, NotificationChain msgs) {
		Time oldTimeSlice = timeSlice;
		timeSlice = newTimeSlice;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__TIME_SLICE, oldTimeSlice, newTimeSlice);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTimeSlice(Time newTimeSlice) {
		if (newTimeSlice != timeSlice) {
			NotificationChain msgs = null;
			if (timeSlice != null)
				msgs = ((InternalEObject)timeSlice).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__TIME_SLICE, null, msgs);
			if (newTimeSlice != null)
				msgs = ((InternalEObject)newTimeSlice).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__TIME_SLICE, null, msgs);
			msgs = basicSetTimeSlice(newTimeSlice, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__TIME_SLICE, newTimeSlice, newTimeSlice));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SchedulingEntry> getTdmaSchedule() {
		if (tdmaSchedule == null) {
			tdmaSchedule = new EObjectContainmentEList<SchedulingEntry>(SchedulingEntry.class, this, ModelPackage.SCHEDULER__TDMA_SCHEDULE);
		}
		return tdmaSchedule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getPeriod() {
		return period;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPeriod(Time newPeriod, NotificationChain msgs) {
		Time oldPeriod = period;
		period = newPeriod;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__PERIOD, oldPeriod, newPeriod);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPeriod(Time newPeriod) {
		if (newPeriod != period) {
			NotificationChain msgs = null;
			if (period != null)
				msgs = ((InternalEObject)period).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__PERIOD, null, msgs);
			if (newPeriod != null)
				msgs = ((InternalEObject)newPeriod).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__PERIOD, null, msgs);
			msgs = basicSetPeriod(newPeriod, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__PERIOD, newPeriod, newPeriod));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSynchronized() {
		return synchronized_;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSynchronized(boolean newSynchronized) {
		boolean oldSynchronized = synchronized_;
		synchronized_ = newSynchronized;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__SYNCHRONIZED, oldSynchronized, synchronized_));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMaxRetard() {
		return maxRetard;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMaxRetard(Time newMaxRetard, NotificationChain msgs) {
		Time oldMaxRetard = maxRetard;
		maxRetard = newMaxRetard;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__MAX_RETARD, oldMaxRetard, newMaxRetard);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxRetard(Time newMaxRetard) {
		if (newMaxRetard != maxRetard) {
			NotificationChain msgs = null;
			if (maxRetard != null)
				msgs = ((InternalEObject)maxRetard).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__MAX_RETARD, null, msgs);
			if (newMaxRetard != null)
				msgs = ((InternalEObject)newMaxRetard).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__MAX_RETARD, null, msgs);
			msgs = basicSetMaxRetard(newMaxRetard, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__MAX_RETARD, newMaxRetard, newMaxRetard));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getMaxAdvance() {
		return maxAdvance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMaxAdvance(Time newMaxAdvance, NotificationChain msgs) {
		Time oldMaxAdvance = maxAdvance;
		maxAdvance = newMaxAdvance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__MAX_ADVANCE, oldMaxAdvance, newMaxAdvance);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxAdvance(Time newMaxAdvance) {
		if (newMaxAdvance != maxAdvance) {
			NotificationChain msgs = null;
			if (maxAdvance != null)
				msgs = ((InternalEObject)maxAdvance).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__MAX_ADVANCE, null, msgs);
			if (newMaxAdvance != null)
				msgs = ((InternalEObject)newMaxAdvance).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULER__MAX_ADVANCE, null, msgs);
			msgs = basicSetMaxAdvance(newMaxAdvance, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__MAX_ADVANCE, newMaxAdvance, newMaxAdvance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelObject getSyncSource() {
		if (syncSource != null && syncSource.eIsProxy()) {
			InternalEObject oldSyncSource = (InternalEObject)syncSource;
			syncSource = (ModelObject)eResolveProxy(oldSyncSource);
			if (syncSource != oldSyncSource) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.SCHEDULER__SYNC_SOURCE, oldSyncSource, syncSource));
			}
		}
		return syncSource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelObject basicGetSyncSource() {
		return syncSource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSyncSource(ModelObject newSyncSource) {
		ModelObject oldSyncSource = syncSource;
		syncSource = newSyncSource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__SYNC_SOURCE, oldSyncSource, syncSource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process getCycleStartProcess() {
		if (cycleStartProcess != null && cycleStartProcess.eIsProxy()) {
			InternalEObject oldCycleStartProcess = (InternalEObject)cycleStartProcess;
			cycleStartProcess = (com.inchron.realtime.root.model.Process)eResolveProxy(oldCycleStartProcess);
			if (cycleStartProcess != oldCycleStartProcess) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.SCHEDULER__CYCLE_START_PROCESS, oldCycleStartProcess, cycleStartProcess));
			}
		}
		return cycleStartProcess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public com.inchron.realtime.root.model.Process basicGetCycleStartProcess() {
		return cycleStartProcess;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCycleStartProcess(com.inchron.realtime.root.model.Process newCycleStartProcess) {
		com.inchron.realtime.root.model.Process oldCycleStartProcess = cycleStartProcess;
		cycleStartProcess = newCycleStartProcess;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__CYCLE_START_PROCESS, oldCycleStartProcess, cycleStartProcess));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPrioritiesPropagated() {
		return prioritiesPropagated;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrioritiesPropagated(boolean newPrioritiesPropagated) {
		boolean oldPrioritiesPropagated = prioritiesPropagated;
		prioritiesPropagated = newPrioritiesPropagated;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__PRIORITIES_PROPAGATED, oldPrioritiesPropagated, prioritiesPropagated));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isPriorityInversed() {
		return priorityInversed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPriorityInversed(boolean newPriorityInversed) {
		boolean oldPriorityInversed = priorityInversed;
		priorityInversed = newPriorityInversed;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULER__PRIORITY_INVERSED, oldPriorityInversed, priorityInversed));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CallbackFunction> getCallbacks() {
		if (callbacks == null) {
			callbacks = new EObjectContainmentEList<CallbackFunction>(CallbackFunction.class, this, ModelPackage.SCHEDULER__CALLBACKS);
		}
		return callbacks;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CpuCore> getCallbackCoreAffinity() {
		if (callbackCoreAffinity == null) {
			callbackCoreAffinity = new EObjectResolvingEList<CpuCore>(CpuCore.class, this, ModelPackage.SCHEDULER__CALLBACK_CORE_AFFINITY);
		}
		return callbackCoreAffinity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.SCHEDULER__SCHEDULABLES:
				return ((InternalEList<?>)getSchedulables()).basicRemove(otherEnd, msgs);
			case ModelPackage.SCHEDULER__TIME_SLICE:
				return basicSetTimeSlice(null, msgs);
			case ModelPackage.SCHEDULER__TDMA_SCHEDULE:
				return ((InternalEList<?>)getTdmaSchedule()).basicRemove(otherEnd, msgs);
			case ModelPackage.SCHEDULER__PERIOD:
				return basicSetPeriod(null, msgs);
			case ModelPackage.SCHEDULER__MAX_RETARD:
				return basicSetMaxRetard(null, msgs);
			case ModelPackage.SCHEDULER__MAX_ADVANCE:
				return basicSetMaxAdvance(null, msgs);
			case ModelPackage.SCHEDULER__CALLBACKS:
				return ((InternalEList<?>)getCallbacks()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SCHEDULER__SCHEDULABLES:
				return getSchedulables();
			case ModelPackage.SCHEDULER__TYPE:
				return getType();
			case ModelPackage.SCHEDULER__STRATEGY:
				return getStrategy();
			case ModelPackage.SCHEDULER__TIME_SLICE:
				return getTimeSlice();
			case ModelPackage.SCHEDULER__TDMA_SCHEDULE:
				return getTdmaSchedule();
			case ModelPackage.SCHEDULER__PERIOD:
				return getPeriod();
			case ModelPackage.SCHEDULER__SYNCHRONIZED:
				return isSynchronized();
			case ModelPackage.SCHEDULER__MAX_RETARD:
				return getMaxRetard();
			case ModelPackage.SCHEDULER__MAX_ADVANCE:
				return getMaxAdvance();
			case ModelPackage.SCHEDULER__SYNC_SOURCE:
				if (resolve) return getSyncSource();
				return basicGetSyncSource();
			case ModelPackage.SCHEDULER__CYCLE_START_PROCESS:
				if (resolve) return getCycleStartProcess();
				return basicGetCycleStartProcess();
			case ModelPackage.SCHEDULER__PRIORITIES_PROPAGATED:
				return isPrioritiesPropagated();
			case ModelPackage.SCHEDULER__PRIORITY_INVERSED:
				return isPriorityInversed();
			case ModelPackage.SCHEDULER__CALLBACKS:
				return getCallbacks();
			case ModelPackage.SCHEDULER__CALLBACK_CORE_AFFINITY:
				return getCallbackCoreAffinity();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SCHEDULER__SCHEDULABLES:
				getSchedulables().clear();
				getSchedulables().addAll((Collection<? extends Schedulable>)newValue);
				return;
			case ModelPackage.SCHEDULER__TYPE:
				setType((SchedulerType)newValue);
				return;
			case ModelPackage.SCHEDULER__STRATEGY:
				setStrategy((SchedulerStrategy)newValue);
				return;
			case ModelPackage.SCHEDULER__TIME_SLICE:
				setTimeSlice((Time)newValue);
				return;
			case ModelPackage.SCHEDULER__TDMA_SCHEDULE:
				getTdmaSchedule().clear();
				getTdmaSchedule().addAll((Collection<? extends SchedulingEntry>)newValue);
				return;
			case ModelPackage.SCHEDULER__PERIOD:
				setPeriod((Time)newValue);
				return;
			case ModelPackage.SCHEDULER__SYNCHRONIZED:
				setSynchronized((Boolean)newValue);
				return;
			case ModelPackage.SCHEDULER__MAX_RETARD:
				setMaxRetard((Time)newValue);
				return;
			case ModelPackage.SCHEDULER__MAX_ADVANCE:
				setMaxAdvance((Time)newValue);
				return;
			case ModelPackage.SCHEDULER__SYNC_SOURCE:
				setSyncSource((ModelObject)newValue);
				return;
			case ModelPackage.SCHEDULER__CYCLE_START_PROCESS:
				setCycleStartProcess((com.inchron.realtime.root.model.Process)newValue);
				return;
			case ModelPackage.SCHEDULER__PRIORITIES_PROPAGATED:
				setPrioritiesPropagated((Boolean)newValue);
				return;
			case ModelPackage.SCHEDULER__PRIORITY_INVERSED:
				setPriorityInversed((Boolean)newValue);
				return;
			case ModelPackage.SCHEDULER__CALLBACKS:
				getCallbacks().clear();
				getCallbacks().addAll((Collection<? extends CallbackFunction>)newValue);
				return;
			case ModelPackage.SCHEDULER__CALLBACK_CORE_AFFINITY:
				getCallbackCoreAffinity().clear();
				getCallbackCoreAffinity().addAll((Collection<? extends CpuCore>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SCHEDULER__SCHEDULABLES:
				getSchedulables().clear();
				return;
			case ModelPackage.SCHEDULER__TYPE:
				setType(TYPE_EDEFAULT);
				return;
			case ModelPackage.SCHEDULER__STRATEGY:
				setStrategy(STRATEGY_EDEFAULT);
				return;
			case ModelPackage.SCHEDULER__TIME_SLICE:
				setTimeSlice((Time)null);
				return;
			case ModelPackage.SCHEDULER__TDMA_SCHEDULE:
				getTdmaSchedule().clear();
				return;
			case ModelPackage.SCHEDULER__PERIOD:
				setPeriod((Time)null);
				return;
			case ModelPackage.SCHEDULER__SYNCHRONIZED:
				setSynchronized(SYNCHRONIZED_EDEFAULT);
				return;
			case ModelPackage.SCHEDULER__MAX_RETARD:
				setMaxRetard((Time)null);
				return;
			case ModelPackage.SCHEDULER__MAX_ADVANCE:
				setMaxAdvance((Time)null);
				return;
			case ModelPackage.SCHEDULER__SYNC_SOURCE:
				setSyncSource((ModelObject)null);
				return;
			case ModelPackage.SCHEDULER__CYCLE_START_PROCESS:
				setCycleStartProcess((com.inchron.realtime.root.model.Process)null);
				return;
			case ModelPackage.SCHEDULER__PRIORITIES_PROPAGATED:
				setPrioritiesPropagated(PRIORITIES_PROPAGATED_EDEFAULT);
				return;
			case ModelPackage.SCHEDULER__PRIORITY_INVERSED:
				setPriorityInversed(PRIORITY_INVERSED_EDEFAULT);
				return;
			case ModelPackage.SCHEDULER__CALLBACKS:
				getCallbacks().clear();
				return;
			case ModelPackage.SCHEDULER__CALLBACK_CORE_AFFINITY:
				getCallbackCoreAffinity().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SCHEDULER__SCHEDULABLES:
				return schedulables != null && !schedulables.isEmpty();
			case ModelPackage.SCHEDULER__TYPE:
				return type != TYPE_EDEFAULT;
			case ModelPackage.SCHEDULER__STRATEGY:
				return strategy != STRATEGY_EDEFAULT;
			case ModelPackage.SCHEDULER__TIME_SLICE:
				return timeSlice != null;
			case ModelPackage.SCHEDULER__TDMA_SCHEDULE:
				return tdmaSchedule != null && !tdmaSchedule.isEmpty();
			case ModelPackage.SCHEDULER__PERIOD:
				return period != null;
			case ModelPackage.SCHEDULER__SYNCHRONIZED:
				return synchronized_ != SYNCHRONIZED_EDEFAULT;
			case ModelPackage.SCHEDULER__MAX_RETARD:
				return maxRetard != null;
			case ModelPackage.SCHEDULER__MAX_ADVANCE:
				return maxAdvance != null;
			case ModelPackage.SCHEDULER__SYNC_SOURCE:
				return syncSource != null;
			case ModelPackage.SCHEDULER__CYCLE_START_PROCESS:
				return cycleStartProcess != null;
			case ModelPackage.SCHEDULER__PRIORITIES_PROPAGATED:
				return prioritiesPropagated != PRIORITIES_PROPAGATED_EDEFAULT;
			case ModelPackage.SCHEDULER__PRIORITY_INVERSED:
				return priorityInversed != PRIORITY_INVERSED_EDEFAULT;
			case ModelPackage.SCHEDULER__CALLBACKS:
				return callbacks != null && !callbacks.isEmpty();
			case ModelPackage.SCHEDULER__CALLBACK_CORE_AFFINITY:
				return callbackCoreAffinity != null && !callbackCoreAffinity.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (type: ");
		result.append(type);
		result.append(", strategy: ");
		result.append(strategy);
		result.append(", synchronized: ");
		result.append(synchronized_);
		result.append(", prioritiesPropagated: ");
		result.append(prioritiesPropagated);
		result.append(", priorityInversed: ");
		result.append(priorityInversed);
		result.append(')');
		return result.toString();
	}

} //SchedulerImpl
