/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.Schedulable;
import com.inchron.realtime.root.model.SchedulingEntry;
import com.inchron.realtime.root.model.Time;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scheduling Entry</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulingEntryImpl#getItem <em>Item</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.SchedulingEntryImpl#getSlotLength <em>Slot Length</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SchedulingEntryImpl extends MinimalEObjectImpl.Container implements SchedulingEntry {
	/**
	 * The cached value of the '{@link #getItem() <em>Item</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getItem()
	 * @generated
	 * @ordered
	 */
	protected Schedulable item;

	/**
	 * The cached value of the '{@link #getSlotLength() <em>Slot Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSlotLength()
	 * @generated
	 * @ordered
	 */
	protected Time slotLength;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SchedulingEntryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getSchedulingEntry();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Schedulable getItem() {
		if (item != null && item.eIsProxy()) {
			InternalEObject oldItem = (InternalEObject)item;
			item = (Schedulable)eResolveProxy(oldItem);
			if (item != oldItem) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.SCHEDULING_ENTRY__ITEM, oldItem, item));
			}
		}
		return item;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Schedulable basicGetItem() {
		return item;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setItem(Schedulable newItem) {
		Schedulable oldItem = item;
		item = newItem;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULING_ENTRY__ITEM, oldItem, item));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Time getSlotLength() {
		return slotLength;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSlotLength(Time newSlotLength, NotificationChain msgs) {
		Time oldSlotLength = slotLength;
		slotLength = newSlotLength;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH, oldSlotLength, newSlotLength);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSlotLength(Time newSlotLength) {
		if (newSlotLength != slotLength) {
			NotificationChain msgs = null;
			if (slotLength != null)
				msgs = ((InternalEObject)slotLength).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH, null, msgs);
			if (newSlotLength != null)
				msgs = ((InternalEObject)newSlotLength).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH, null, msgs);
			msgs = basicSetSlotLength(newSlotLength, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH, newSlotLength, newSlotLength));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH:
				return basicSetSlotLength(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.SCHEDULING_ENTRY__ITEM:
				if (resolve) return getItem();
				return basicGetItem();
			case ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH:
				return getSlotLength();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.SCHEDULING_ENTRY__ITEM:
				setItem((Schedulable)newValue);
				return;
			case ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH:
				setSlotLength((Time)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.SCHEDULING_ENTRY__ITEM:
				setItem((Schedulable)null);
				return;
			case ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH:
				setSlotLength((Time)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.SCHEDULING_ENTRY__ITEM:
				return item != null;
			case ModelPackage.SCHEDULING_ENTRY__SLOT_LENGTH:
				return slotLength != null;
		}
		return super.eIsSet(featureID);
	}

} //SchedulingEntryImpl
