/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory.impl;

import com.inchron.realtime.root.model.Clock;
import com.inchron.realtime.root.model.ClockUser;
import com.inchron.realtime.root.model.ModelPackage;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import com.inchron.realtime.root.model.memory.InitiatorPort;
import com.inchron.realtime.root.model.memory.Interconnect;
import com.inchron.realtime.root.model.memory.InterconnectScheduling;
import com.inchron.realtime.root.model.memory.MemoryPackage;
import com.inchron.realtime.root.model.memory.QosEntry;
import com.inchron.realtime.root.model.memory.ResponderPort;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interconnect</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getClock <em>Clock</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getBitWidth <em>Bit Width</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getSchedulingPolicy <em>Scheduling Policy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getConnectedSlaves <em>Connected Slaves</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getConnectedMasters <em>Connected Masters</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getPrescaler <em>Prescaler</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.InterconnectImpl#getQosEntries <em>Qos Entries</em>}</li>
 * </ul>
 *
 * @generated
 */
public class InterconnectImpl extends ModelObjectImpl implements Interconnect {
	/**
	 * The cached value of the '{@link #getClock() <em>Clock</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getClock()
	 * @generated
	 * @ordered
	 */
	protected Clock clock;

	/**
	 * The default value of the '{@link #getBitWidth() <em>Bit Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBitWidth()
	 * @generated
	 * @ordered
	 */
	protected static final int BIT_WIDTH_EDEFAULT = 32;

	/**
	 * The cached value of the '{@link #getBitWidth() <em>Bit Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBitWidth()
	 * @generated
	 * @ordered
	 */
	protected int bitWidth = BIT_WIDTH_EDEFAULT;

	/**
	 * The default value of the '{@link #getSchedulingPolicy() <em>Scheduling Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSchedulingPolicy()
	 * @generated
	 * @ordered
	 */
	protected static final InterconnectScheduling SCHEDULING_POLICY_EDEFAULT = InterconnectScheduling.PRIORITY;

	/**
	 * The cached value of the '{@link #getSchedulingPolicy() <em>Scheduling Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSchedulingPolicy()
	 * @generated
	 * @ordered
	 */
	protected InterconnectScheduling schedulingPolicy = SCHEDULING_POLICY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getConnectedSlaves() <em>Connected Slaves</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnectedSlaves()
	 * @generated
	 * @ordered
	 */
	protected EList<InitiatorPort> connectedSlaves;

	/**
	 * The cached value of the '{@link #getConnectedMasters() <em>Connected Masters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnectedMasters()
	 * @generated
	 * @ordered
	 */
	protected EList<ResponderPort> connectedMasters;

	/**
	 * The default value of the '{@link #getPrescaler() <em>Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrescaler()
	 * @generated
	 * @ordered
	 */
	protected static final double PRESCALER_EDEFAULT = 1.0;

	/**
	 * The cached value of the '{@link #getPrescaler() <em>Prescaler</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPrescaler()
	 * @generated
	 * @ordered
	 */
	protected double prescaler = PRESCALER_EDEFAULT;

	/**
	 * The cached value of the '{@link #getQosEntries() <em>Qos Entries</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getQosEntries()
	 * @generated
	 * @ordered
	 */
	protected EList<QosEntry> qosEntries;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InterconnectImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MemoryPackage.Literals.INTERCONNECT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Clock getClock() {
		if (clock != null && clock.eIsProxy()) {
			InternalEObject oldClock = (InternalEObject)clock;
			clock = (Clock)eResolveProxy(oldClock);
			if (clock != oldClock) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MemoryPackage.INTERCONNECT__CLOCK, oldClock, clock));
			}
		}
		return clock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Clock basicGetClock() {
		return clock;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetClock(Clock newClock, NotificationChain msgs) {
		Clock oldClock = clock;
		clock = newClock;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, MemoryPackage.INTERCONNECT__CLOCK, oldClock, newClock);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setClock(Clock newClock) {
		if (newClock != clock) {
			NotificationChain msgs = null;
			if (clock != null)
				msgs = ((InternalEObject)clock).eInverseRemove(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
			if (newClock != null)
				msgs = ((InternalEObject)newClock).eInverseAdd(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
			msgs = basicSetClock(newClock, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.INTERCONNECT__CLOCK, newClock, newClock));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getBitWidth() {
		return bitWidth;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBitWidth(int newBitWidth) {
		int oldBitWidth = bitWidth;
		bitWidth = newBitWidth;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.INTERCONNECT__BIT_WIDTH, oldBitWidth, bitWidth));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterconnectScheduling getSchedulingPolicy() {
		return schedulingPolicy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSchedulingPolicy(InterconnectScheduling newSchedulingPolicy) {
		InterconnectScheduling oldSchedulingPolicy = schedulingPolicy;
		schedulingPolicy = newSchedulingPolicy == null ? SCHEDULING_POLICY_EDEFAULT : newSchedulingPolicy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.INTERCONNECT__SCHEDULING_POLICY, oldSchedulingPolicy, schedulingPolicy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InitiatorPort> getConnectedSlaves() {
		if (connectedSlaves == null) {
			connectedSlaves = new EObjectContainmentEList<InitiatorPort>(InitiatorPort.class, this, MemoryPackage.INTERCONNECT__CONNECTED_SLAVES);
		}
		return connectedSlaves;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ResponderPort> getConnectedMasters() {
		if (connectedMasters == null) {
			connectedMasters = new EObjectContainmentEList<ResponderPort>(ResponderPort.class, this, MemoryPackage.INTERCONNECT__CONNECTED_MASTERS);
		}
		return connectedMasters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getPrescaler() {
		return prescaler;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPrescaler(double newPrescaler) {
		double oldPrescaler = prescaler;
		prescaler = newPrescaler;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.INTERCONNECT__PRESCALER, oldPrescaler, prescaler));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<QosEntry> getQosEntries() {
		if (qosEntries == null) {
			qosEntries = new EObjectContainmentEList<QosEntry>(QosEntry.class, this, MemoryPackage.INTERCONNECT__QOS_ENTRIES);
		}
		return qosEntries;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MemoryPackage.INTERCONNECT__CLOCK:
				if (clock != null)
					msgs = ((InternalEObject)clock).eInverseRemove(this, ModelPackage.CLOCK__USERS, Clock.class, msgs);
				return basicSetClock((Clock)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case MemoryPackage.INTERCONNECT__CLOCK:
				return basicSetClock(null, msgs);
			case MemoryPackage.INTERCONNECT__CONNECTED_SLAVES:
				return ((InternalEList<?>)getConnectedSlaves()).basicRemove(otherEnd, msgs);
			case MemoryPackage.INTERCONNECT__CONNECTED_MASTERS:
				return ((InternalEList<?>)getConnectedMasters()).basicRemove(otherEnd, msgs);
			case MemoryPackage.INTERCONNECT__QOS_ENTRIES:
				return ((InternalEList<?>)getQosEntries()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MemoryPackage.INTERCONNECT__CLOCK:
				if (resolve) return getClock();
				return basicGetClock();
			case MemoryPackage.INTERCONNECT__BIT_WIDTH:
				return getBitWidth();
			case MemoryPackage.INTERCONNECT__SCHEDULING_POLICY:
				return getSchedulingPolicy();
			case MemoryPackage.INTERCONNECT__CONNECTED_SLAVES:
				return getConnectedSlaves();
			case MemoryPackage.INTERCONNECT__CONNECTED_MASTERS:
				return getConnectedMasters();
			case MemoryPackage.INTERCONNECT__PRESCALER:
				return getPrescaler();
			case MemoryPackage.INTERCONNECT__QOS_ENTRIES:
				return getQosEntries();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MemoryPackage.INTERCONNECT__CLOCK:
				setClock((Clock)newValue);
				return;
			case MemoryPackage.INTERCONNECT__BIT_WIDTH:
				setBitWidth((Integer)newValue);
				return;
			case MemoryPackage.INTERCONNECT__SCHEDULING_POLICY:
				setSchedulingPolicy((InterconnectScheduling)newValue);
				return;
			case MemoryPackage.INTERCONNECT__CONNECTED_SLAVES:
				getConnectedSlaves().clear();
				getConnectedSlaves().addAll((Collection<? extends InitiatorPort>)newValue);
				return;
			case MemoryPackage.INTERCONNECT__CONNECTED_MASTERS:
				getConnectedMasters().clear();
				getConnectedMasters().addAll((Collection<? extends ResponderPort>)newValue);
				return;
			case MemoryPackage.INTERCONNECT__PRESCALER:
				setPrescaler((Double)newValue);
				return;
			case MemoryPackage.INTERCONNECT__QOS_ENTRIES:
				getQosEntries().clear();
				getQosEntries().addAll((Collection<? extends QosEntry>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MemoryPackage.INTERCONNECT__CLOCK:
				setClock((Clock)null);
				return;
			case MemoryPackage.INTERCONNECT__BIT_WIDTH:
				setBitWidth(BIT_WIDTH_EDEFAULT);
				return;
			case MemoryPackage.INTERCONNECT__SCHEDULING_POLICY:
				setSchedulingPolicy(SCHEDULING_POLICY_EDEFAULT);
				return;
			case MemoryPackage.INTERCONNECT__CONNECTED_SLAVES:
				getConnectedSlaves().clear();
				return;
			case MemoryPackage.INTERCONNECT__CONNECTED_MASTERS:
				getConnectedMasters().clear();
				return;
			case MemoryPackage.INTERCONNECT__PRESCALER:
				setPrescaler(PRESCALER_EDEFAULT);
				return;
			case MemoryPackage.INTERCONNECT__QOS_ENTRIES:
				getQosEntries().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MemoryPackage.INTERCONNECT__CLOCK:
				return clock != null;
			case MemoryPackage.INTERCONNECT__BIT_WIDTH:
				return bitWidth != BIT_WIDTH_EDEFAULT;
			case MemoryPackage.INTERCONNECT__SCHEDULING_POLICY:
				return schedulingPolicy != SCHEDULING_POLICY_EDEFAULT;
			case MemoryPackage.INTERCONNECT__CONNECTED_SLAVES:
				return connectedSlaves != null && !connectedSlaves.isEmpty();
			case MemoryPackage.INTERCONNECT__CONNECTED_MASTERS:
				return connectedMasters != null && !connectedMasters.isEmpty();
			case MemoryPackage.INTERCONNECT__PRESCALER:
				return prescaler != PRESCALER_EDEFAULT;
			case MemoryPackage.INTERCONNECT__QOS_ENTRIES:
				return qosEntries != null && !qosEntries.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ClockUser.class) {
			switch (derivedFeatureID) {
				case MemoryPackage.INTERCONNECT__CLOCK: return ModelPackage.CLOCK_USER__CLOCK;
				default: return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ClockUser.class) {
			switch (baseFeatureID) {
				case ModelPackage.CLOCK_USER__CLOCK: return MemoryPackage.INTERCONNECT__CLOCK;
				default: return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (bitWidth: ");
		result.append(bitWidth);
		result.append(", schedulingPolicy: ");
		result.append(schedulingPolicy);
		result.append(", prescaler: ");
		result.append(prescaler);
		result.append(')');
		return result.toString();
	}

} //InterconnectImpl
