/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.memory.impl;

import com.inchron.realtime.root.model.memory.InitiatorPort;
import com.inchron.realtime.root.model.memory.MemoryPackage;
import com.inchron.realtime.root.model.memory.QosEntry;
import com.inchron.realtime.root.model.memory.ResponderPort;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Qos Entry</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.QosEntryImpl#getPriority <em>Priority</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.QosEntryImpl#getMinimumBandwidth <em>Minimum Bandwidth</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.QosEntryImpl#getInPort <em>In Port</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.memory.impl.QosEntryImpl#getOutPort <em>Out Port</em>}</li>
 * </ul>
 *
 * @generated
 */
public class QosEntryImpl extends MinimalEObjectImpl.Container implements QosEntry {
	/**
	 * The default value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected static final int PRIORITY_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getPriority() <em>Priority</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPriority()
	 * @generated
	 * @ordered
	 */
	protected int priority = PRIORITY_EDEFAULT;

	/**
	 * The default value of the '{@link #getMinimumBandwidth() <em>Minimum Bandwidth</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimumBandwidth()
	 * @generated
	 * @ordered
	 */
	protected static final int MINIMUM_BANDWIDTH_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getMinimumBandwidth() <em>Minimum Bandwidth</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinimumBandwidth()
	 * @generated
	 * @ordered
	 */
	protected int minimumBandwidth = MINIMUM_BANDWIDTH_EDEFAULT;

	/**
	 * The cached value of the '{@link #getInPort() <em>In Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInPort()
	 * @generated
	 * @ordered
	 */
	protected ResponderPort inPort;

	/**
	 * The cached value of the '{@link #getOutPort() <em>Out Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutPort()
	 * @generated
	 * @ordered
	 */
	protected InitiatorPort outPort;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected QosEntryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MemoryPackage.Literals.QOS_ENTRY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getPriority() {
		return priority;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPriority(int newPriority) {
		int oldPriority = priority;
		priority = newPriority;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.QOS_ENTRY__PRIORITY, oldPriority, priority));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMinimumBandwidth() {
		return minimumBandwidth;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinimumBandwidth(int newMinimumBandwidth) {
		int oldMinimumBandwidth = minimumBandwidth;
		minimumBandwidth = newMinimumBandwidth;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.QOS_ENTRY__MINIMUM_BANDWIDTH, oldMinimumBandwidth, minimumBandwidth));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResponderPort getInPort() {
		if (inPort != null && inPort.eIsProxy()) {
			InternalEObject oldInPort = (InternalEObject)inPort;
			inPort = (ResponderPort)eResolveProxy(oldInPort);
			if (inPort != oldInPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MemoryPackage.QOS_ENTRY__IN_PORT, oldInPort, inPort));
			}
		}
		return inPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResponderPort basicGetInPort() {
		return inPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInPort(ResponderPort newInPort) {
		ResponderPort oldInPort = inPort;
		inPort = newInPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.QOS_ENTRY__IN_PORT, oldInPort, inPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InitiatorPort getOutPort() {
		if (outPort != null && outPort.eIsProxy()) {
			InternalEObject oldOutPort = (InternalEObject)outPort;
			outPort = (InitiatorPort)eResolveProxy(oldOutPort);
			if (outPort != oldOutPort) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, MemoryPackage.QOS_ENTRY__OUT_PORT, oldOutPort, outPort));
			}
		}
		return outPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InitiatorPort basicGetOutPort() {
		return outPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOutPort(InitiatorPort newOutPort) {
		InitiatorPort oldOutPort = outPort;
		outPort = newOutPort;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MemoryPackage.QOS_ENTRY__OUT_PORT, oldOutPort, outPort));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case MemoryPackage.QOS_ENTRY__PRIORITY:
				return getPriority();
			case MemoryPackage.QOS_ENTRY__MINIMUM_BANDWIDTH:
				return getMinimumBandwidth();
			case MemoryPackage.QOS_ENTRY__IN_PORT:
				if (resolve) return getInPort();
				return basicGetInPort();
			case MemoryPackage.QOS_ENTRY__OUT_PORT:
				if (resolve) return getOutPort();
				return basicGetOutPort();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case MemoryPackage.QOS_ENTRY__PRIORITY:
				setPriority((Integer)newValue);
				return;
			case MemoryPackage.QOS_ENTRY__MINIMUM_BANDWIDTH:
				setMinimumBandwidth((Integer)newValue);
				return;
			case MemoryPackage.QOS_ENTRY__IN_PORT:
				setInPort((ResponderPort)newValue);
				return;
			case MemoryPackage.QOS_ENTRY__OUT_PORT:
				setOutPort((InitiatorPort)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case MemoryPackage.QOS_ENTRY__PRIORITY:
				setPriority(PRIORITY_EDEFAULT);
				return;
			case MemoryPackage.QOS_ENTRY__MINIMUM_BANDWIDTH:
				setMinimumBandwidth(MINIMUM_BANDWIDTH_EDEFAULT);
				return;
			case MemoryPackage.QOS_ENTRY__IN_PORT:
				setInPort((ResponderPort)null);
				return;
			case MemoryPackage.QOS_ENTRY__OUT_PORT:
				setOutPort((InitiatorPort)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case MemoryPackage.QOS_ENTRY__PRIORITY:
				return priority != PRIORITY_EDEFAULT;
			case MemoryPackage.QOS_ENTRY__MINIMUM_BANDWIDTH:
				return minimumBandwidth != MINIMUM_BANDWIDTH_EDEFAULT;
			case MemoryPackage.QOS_ENTRY__IN_PORT:
				return inPort != null;
			case MemoryPackage.QOS_ENTRY__OUT_PORT:
				return outPort != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (priority: ");
		result.append(priority);
		result.append(", minimumBandwidth: ");
		result.append(minimumBandwidth);
		result.append(')');
		return result.toString();
	}

} //QosEntryImpl
