/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Flex Ray</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#isColdStarter <em>Cold Starter</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPSingleSlotEnabled <em>PSingle Slot Enabled</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPKeySlotId <em>PKey Slot Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForStartup <em>PKey Slot Used For Startup</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForSync <em>PKey Slot Used For Sync</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdMicrotick <em>Pd Microtick</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPLatestTx <em>PLatest Tx</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdListenTimeOut <em>Pd Listen Time Out</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdMaxDrift <em>Pd Max Drift</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPAllowHaltDueToClock <em>PAllow Halt Due To Clock</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPAllowPassiveToActive <em>PAllow Passive To Active</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPOffsetCorrectionOut <em>POffset Correction Out</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPRateCorrectionOut <em>PRate Correction Out</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay()
 * @model
 * @generated
 */
public interface FlexRay extends Peripheral {
	/**
	 * Returns the value of the '<em><b>Cold Starter</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cold Starter</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cold Starter</em>' attribute.
	 * @see #setColdStarter(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_ColdStarter()
	 * @model default="false"
	 * @generated
	 */
	boolean isColdStarter();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isColdStarter <em>Cold Starter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cold Starter</em>' attribute.
	 * @see #isColdStarter()
	 * @generated
	 */
	void setColdStarter(boolean value);

	/**
	 * Returns the value of the '<em><b>PSingle Slot Enabled</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PSingle Slot Enabled</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PSingle Slot Enabled</em>' attribute.
	 * @see #setPSingleSlotEnabled(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PSingleSlotEnabled()
	 * @model default="false"
	 * @generated
	 */
	boolean isPSingleSlotEnabled();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPSingleSlotEnabled <em>PSingle Slot Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PSingle Slot Enabled</em>' attribute.
	 * @see #isPSingleSlotEnabled()
	 * @generated
	 */
	void setPSingleSlotEnabled(boolean value);

	/**
	 * Returns the value of the '<em><b>PKey Slot Id</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PKey Slot Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PKey Slot Id</em>' attribute.
	 * @see #setPKeySlotId(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PKeySlotId()
	 * @model default="1"
	 * @generated
	 */
	int getPKeySlotId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPKeySlotId <em>PKey Slot Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PKey Slot Id</em>' attribute.
	 * @see #getPKeySlotId()
	 * @generated
	 */
	void setPKeySlotId(int value);

	/**
	 * Returns the value of the '<em><b>PKey Slot Used For Startup</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PKey Slot Used For Startup</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PKey Slot Used For Startup</em>' attribute.
	 * @see #setPKeySlotUsedForStartup(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PKeySlotUsedForStartup()
	 * @model default="false"
	 * @generated
	 */
	boolean isPKeySlotUsedForStartup();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForStartup <em>PKey Slot Used For Startup</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PKey Slot Used For Startup</em>' attribute.
	 * @see #isPKeySlotUsedForStartup()
	 * @generated
	 */
	void setPKeySlotUsedForStartup(boolean value);

	/**
	 * Returns the value of the '<em><b>PKey Slot Used For Sync</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PKey Slot Used For Sync</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PKey Slot Used For Sync</em>' attribute.
	 * @see #setPKeySlotUsedForSync(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PKeySlotUsedForSync()
	 * @model default="false"
	 * @generated
	 */
	boolean isPKeySlotUsedForSync();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPKeySlotUsedForSync <em>PKey Slot Used For Sync</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PKey Slot Used For Sync</em>' attribute.
	 * @see #isPKeySlotUsedForSync()
	 * @generated
	 */
	void setPKeySlotUsedForSync(boolean value);

	/**
	 * Returns the value of the '<em><b>Pd Microtick</b></em>' attribute.
	 * The default value is <code>"0.025"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pd Microtick</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pd Microtick</em>' attribute.
	 * @see #setPdMicrotick(double)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PdMicrotick()
	 * @model default="0.025"
	 * @generated
	 */
	double getPdMicrotick();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdMicrotick <em>Pd Microtick</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pd Microtick</em>' attribute.
	 * @see #getPdMicrotick()
	 * @generated
	 */
	void setPdMicrotick(double value);

	/**
	 * Returns the value of the '<em><b>PLatest Tx</b></em>' attribute.
	 * The default value is <code>"243"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PLatest Tx</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PLatest Tx</em>' attribute.
	 * @see #setPLatestTx(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PLatestTx()
	 * @model default="243"
	 * @generated
	 */
	int getPLatestTx();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPLatestTx <em>PLatest Tx</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PLatest Tx</em>' attribute.
	 * @see #getPLatestTx()
	 * @generated
	 */
	void setPLatestTx(int value);

	/**
	 * Returns the value of the '<em><b>Pd Listen Time Out</b></em>' attribute.
	 * The default value is <code>"401202"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pd Listen Time Out</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pd Listen Time Out</em>' attribute.
	 * @see #setPdListenTimeOut(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PdListenTimeOut()
	 * @model default="401202"
	 * @generated
	 */
	int getPdListenTimeOut();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdListenTimeOut <em>Pd Listen Time Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pd Listen Time Out</em>' attribute.
	 * @see #getPdListenTimeOut()
	 * @generated
	 */
	void setPdListenTimeOut(int value);

	/**
	 * Returns the value of the '<em><b>Pd Max Drift</b></em>' attribute.
	 * The default value is <code>"601"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pd Max Drift</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pd Max Drift</em>' attribute.
	 * @see #setPdMaxDrift(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PdMaxDrift()
	 * @model default="601"
	 * @generated
	 */
	int getPdMaxDrift();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPdMaxDrift <em>Pd Max Drift</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pd Max Drift</em>' attribute.
	 * @see #getPdMaxDrift()
	 * @generated
	 */
	void setPdMaxDrift(int value);

	/**
	 * Returns the value of the '<em><b>PAllow Halt Due To Clock</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PAllow Halt Due To Clock</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PAllow Halt Due To Clock</em>' attribute.
	 * @see #setPAllowHaltDueToClock(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PAllowHaltDueToClock()
	 * @model default="false"
	 * @generated
	 */
	boolean isPAllowHaltDueToClock();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#isPAllowHaltDueToClock <em>PAllow Halt Due To Clock</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PAllow Halt Due To Clock</em>' attribute.
	 * @see #isPAllowHaltDueToClock()
	 * @generated
	 */
	void setPAllowHaltDueToClock(boolean value);

	/**
	 * Returns the value of the '<em><b>PAllow Passive To Active</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PAllow Passive To Active</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PAllow Passive To Active</em>' attribute.
	 * @see #setPAllowPassiveToActive(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PAllowPassiveToActive()
	 * @model default="1"
	 * @generated
	 */
	int getPAllowPassiveToActive();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPAllowPassiveToActive <em>PAllow Passive To Active</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PAllow Passive To Active</em>' attribute.
	 * @see #getPAllowPassiveToActive()
	 * @generated
	 */
	void setPAllowPassiveToActive(int value);

	/**
	 * Returns the value of the '<em><b>POffset Correction Out</b></em>' attribute.
	 * The default value is <code>"261"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>POffset Correction Out</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>POffset Correction Out</em>' attribute.
	 * @see #setPOffsetCorrectionOut(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_POffsetCorrectionOut()
	 * @model default="261"
	 * @generated
	 */
	int getPOffsetCorrectionOut();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPOffsetCorrectionOut <em>POffset Correction Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>POffset Correction Out</em>' attribute.
	 * @see #getPOffsetCorrectionOut()
	 * @generated
	 */
	void setPOffsetCorrectionOut(int value);

	/**
	 * Returns the value of the '<em><b>PRate Correction Out</b></em>' attribute.
	 * The default value is <code>"601"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>PRate Correction Out</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>PRate Correction Out</em>' attribute.
	 * @see #setPRateCorrectionOut(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getFlexRay_PRateCorrectionOut()
	 * @model default="601"
	 * @generated
	 */
	int getPRateCorrectionOut();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.FlexRay#getPRateCorrectionOut <em>PRate Correction Out</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>PRate Correction Out</em>' attribute.
	 * @see #getPRateCorrectionOut()
	 * @generated
	 */
	void setPRateCorrectionOut(int value);

} // FlexRay
