/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.TraceEvent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Timing Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getTrigger <em>Trigger</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStart <em>Start</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStop <em>Stop</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventTimingRequirement()
 * @model
 * @generated
 */
public interface EventTimingRequirement extends TimingRequirement {
	/**
	 * Returns the value of the '<em><b>Trigger</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Trigger</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Trigger</em>' reference.
	 * @see #setTrigger(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventTimingRequirement_Trigger()
	 * @model
	 * @generated
	 */
	TraceEvent getTrigger();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getTrigger <em>Trigger</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Trigger</em>' reference.
	 * @see #getTrigger()
	 * @generated
	 */
	void setTrigger(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start</em>' reference.
	 * @see #setStart(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventTimingRequirement_Start()
	 * @model required="true"
	 * @generated
	 */
	TraceEvent getStart();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStart <em>Start</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start</em>' reference.
	 * @see #getStart()
	 * @generated
	 */
	void setStart(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Stop</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stop</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stop</em>' reference.
	 * @see #setStop(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventTimingRequirement_Stop()
	 * @model required="true"
	 * @generated
	 */
	TraceEvent getStop();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventTimingRequirement#getStop <em>Stop</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Stop</em>' reference.
	 * @see #getStop()
	 * @generated
	 */
	void setStop(TraceEvent value);

} // EventTimingRequirement
