/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.LoadResource;
import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Load Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getGranularity <em>Granularity</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getLimit <em>Limit</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getLoadResource <em>Load Resource</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getPrewarnMargin <em>Prewarn Margin</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getRelationalOperator <em>Relational Operator</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getSteps <em>Steps</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement()
 * @model
 * @generated
 */
public interface LoadRequirement extends Requirement {
	/**
	 * Returns the value of the '<em><b>Granularity</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Granularity</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Granularity</em>' containment reference.
	 * @see #setGranularity(Time)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement_Granularity()
	 * @model containment="true"
	 * @generated
	 */
	Time getGranularity();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getGranularity <em>Granularity</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Granularity</em>' containment reference.
	 * @see #getGranularity()
	 * @generated
	 */
	void setGranularity(Time value);

	/**
	 * Returns the value of the '<em><b>Limit</b></em>' attribute.
	 * The default value is <code>"80"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Limit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Limit</em>' attribute.
	 * @see #setLimit(float)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement_Limit()
	 * @model default="80"
	 * @generated
	 */
	float getLimit();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getLimit <em>Limit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Limit</em>' attribute.
	 * @see #getLimit()
	 * @generated
	 */
	void setLimit(float value);

	/**
	 * Returns the value of the '<em><b>Load Resource</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Load Resource</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Load Resource</em>' reference.
	 * @see #setLoadResource(LoadResource)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement_LoadResource()
	 * @model
	 * @generated
	 */
	LoadResource getLoadResource();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getLoadResource <em>Load Resource</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Load Resource</em>' reference.
	 * @see #getLoadResource()
	 * @generated
	 */
	void setLoadResource(LoadResource value);

	/**
	 * Returns the value of the '<em><b>Prewarn Margin</b></em>' attribute.
	 * The default value is <code>"10"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Prewarn Margin</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Prewarn Margin</em>' attribute.
	 * @see #setPrewarnMargin(float)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement_PrewarnMargin()
	 * @model default="10"
	 * @generated
	 */
	float getPrewarnMargin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getPrewarnMargin <em>Prewarn Margin</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Prewarn Margin</em>' attribute.
	 * @see #getPrewarnMargin()
	 * @generated
	 */
	void setPrewarnMargin(float value);

	/**
	 * Returns the value of the '<em><b>Relational Operator</b></em>' attribute.
	 * The default value is <code>"le"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relational Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relational Operator</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe
	 * @see #setRelationalOperator(RelationalOperatorLeGe)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement_RelationalOperator()
	 * @model default="le"
	 * @generated
	 */
	RelationalOperatorLeGe getRelationalOperator();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getRelationalOperator <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Relational Operator</em>' attribute.
	 * @see com.inchron.realtime.root.model.requirement.RelationalOperatorLeGe
	 * @see #getRelationalOperator()
	 * @generated
	 */
	void setRelationalOperator(RelationalOperatorLeGe value);

	/**
	 * Returns the value of the '<em><b>Steps</b></em>' attribute.
	 * The default value is <code>"20"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Steps</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Steps</em>' attribute.
	 * @see #setSteps(int)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getLoadRequirement_Steps()
	 * @model default="20"
	 * @generated
	 */
	int getSteps();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.LoadRequirement#getSteps <em>Steps</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Steps</em>' attribute.
	 * @see #getSteps()
	 * @generated
	 */
	void setSteps(int value);

} // LoadRequirement
