/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.requirement.Evaluation;
import com.inchron.realtime.root.model.requirement.RequirementPackage;
import com.inchron.realtime.root.model.requirement.Verdict;

import java.util.Date;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Evaluation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EvaluationImpl#getProvidedBy <em>Provided By</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EvaluationImpl#getTimeCreated <em>Time Created</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EvaluationImpl#getVerdict <em>Verdict</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EvaluationImpl extends MinimalEObjectImpl.Container implements Evaluation {
	/**
	 * The default value of the '{@link #getProvidedBy() <em>Provided By</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidedBy()
	 * @generated
	 * @ordered
	 */
	protected static final String PROVIDED_BY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getProvidedBy() <em>Provided By</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidedBy()
	 * @generated
	 * @ordered
	 */
	protected String providedBy = PROVIDED_BY_EDEFAULT;

	/**
	 * The default value of the '{@link #getTimeCreated() <em>Time Created</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeCreated()
	 * @generated
	 * @ordered
	 */
	protected static final Date TIME_CREATED_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTimeCreated() <em>Time Created</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeCreated()
	 * @generated
	 * @ordered
	 */
	protected Date timeCreated = TIME_CREATED_EDEFAULT;

	/**
	 * The default value of the '{@link #getVerdict() <em>Verdict</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVerdict()
	 * @generated
	 * @ordered
	 */
	protected static final Verdict VERDICT_EDEFAULT = Verdict.UNKNOWN;

	/**
	 * The cached value of the '{@link #getVerdict() <em>Verdict</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVerdict()
	 * @generated
	 * @ordered
	 */
	protected Verdict verdict = VERDICT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EvaluationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.EVALUATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getProvidedBy() {
		return providedBy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProvidedBy(String newProvidedBy) {
		String oldProvidedBy = providedBy;
		providedBy = newProvidedBy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVALUATION__PROVIDED_BY, oldProvidedBy, providedBy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Date getTimeCreated() {
		return timeCreated;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTimeCreated(Date newTimeCreated) {
		Date oldTimeCreated = timeCreated;
		timeCreated = newTimeCreated;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVALUATION__TIME_CREATED, oldTimeCreated, timeCreated));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Verdict getVerdict() {
		return verdict;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVerdict(Verdict newVerdict) {
		Verdict oldVerdict = verdict;
		verdict = newVerdict == null ? VERDICT_EDEFAULT : newVerdict;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVALUATION__VERDICT, oldVerdict, verdict));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.EVALUATION__PROVIDED_BY:
				return getProvidedBy();
			case RequirementPackage.EVALUATION__TIME_CREATED:
				return getTimeCreated();
			case RequirementPackage.EVALUATION__VERDICT:
				return getVerdict();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.EVALUATION__PROVIDED_BY:
				setProvidedBy((String)newValue);
				return;
			case RequirementPackage.EVALUATION__TIME_CREATED:
				setTimeCreated((Date)newValue);
				return;
			case RequirementPackage.EVALUATION__VERDICT:
				setVerdict((Verdict)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVALUATION__PROVIDED_BY:
				setProvidedBy(PROVIDED_BY_EDEFAULT);
				return;
			case RequirementPackage.EVALUATION__TIME_CREATED:
				setTimeCreated(TIME_CREATED_EDEFAULT);
				return;
			case RequirementPackage.EVALUATION__VERDICT:
				setVerdict(VERDICT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVALUATION__PROVIDED_BY:
				return PROVIDED_BY_EDEFAULT == null ? providedBy != null : !PROVIDED_BY_EDEFAULT.equals(providedBy);
			case RequirementPackage.EVALUATION__TIME_CREATED:
				return TIME_CREATED_EDEFAULT == null ? timeCreated != null : !TIME_CREATED_EDEFAULT.equals(timeCreated);
			case RequirementPackage.EVALUATION__VERDICT:
				return verdict != VERDICT_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (providedBy: ");
		result.append(providedBy);
		result.append(", timeCreated: ");
		result.append(timeCreated);
		result.append(", verdict: ");
		result.append(verdict);
		result.append(')');
		return result.toString();
	}

} //EvaluationImpl
