/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.RootPackage;
import com.inchron.realtime.root.impl.RootPackageImpl;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.autosar.AutosarPackage;
import com.inchron.realtime.root.model.autosar.impl.AutosarPackageImpl;
import com.inchron.realtime.root.model.fmi.FmiPackage;
import com.inchron.realtime.root.model.fmi.impl.FmiPackageImpl;
import com.inchron.realtime.root.model.fmi.type.TypePackage;
import com.inchron.realtime.root.model.fmi.type.impl.TypePackageImpl;
import com.inchron.realtime.root.model.fmi.unit.UnitPackage;
import com.inchron.realtime.root.model.fmi.unit.impl.UnitPackageImpl;
import com.inchron.realtime.root.model.fmi.variable.VariablePackage;
import com.inchron.realtime.root.model.fmi.variable.impl.VariablePackageImpl;
import com.inchron.realtime.root.model.impl.ModelPackageImpl;
import com.inchron.realtime.root.model.memory.MemoryPackage;
import com.inchron.realtime.root.model.memory.impl.MemoryPackageImpl;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;
import com.inchron.realtime.root.model.peripheral.impl.PeripheralPackageImpl;
import com.inchron.realtime.root.model.requirement.RequirementFactory;
import com.inchron.realtime.root.model.requirement.RequirementPackage;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;
import com.inchron.realtime.root.model.stimulation.impl.StimulationPackageImpl;
import com.inchron.realtime.root.settings.SettingsPackage;
import com.inchron.realtime.root.settings.impl.SettingsPackageImpl;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class RequirementPackageImpl extends EPackageImpl implements RequirementPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callNestingRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass evaluationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventChainBreakOffRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventChainJoinRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventChainMultipleProcessingRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventChainTimingRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventIEventJRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventNetExecTimeRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventTimingRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass groupOfRequirementsEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass illegalEventRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loadRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass netExecTimeRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass netSlackTimeRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass periodicEventRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass recursionRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass requirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass responseTimeRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass rtosFailureRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timingRequirementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum eventChainStrategyEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum netSlackTimeRequirementTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum relationalOperatorEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum relationalOperatorLeGeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum relationalOperatorLtLeGtGeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum rtosFailureEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum verdictEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private RequirementPackageImpl() {
		super(eNS_URI, RequirementFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link RequirementPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @generated
	 */
	public static RequirementPackage init() {
		if (isInited) return (RequirementPackage)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI);

		// Obtain or create and register package
		RequirementPackageImpl theRequirementPackage = (RequirementPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof RequirementPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new RequirementPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		RootPackageImpl theRootPackage = (RootPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) instanceof RootPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(RootPackage.eNS_URI) : RootPackage.eINSTANCE);
		ModelPackageImpl theModelPackage = (ModelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) instanceof ModelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) : ModelPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		FmiPackageImpl theFmiPackage = (FmiPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) instanceof FmiPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FmiPackage.eNS_URI) : FmiPackage.eINSTANCE);
		TypePackageImpl theTypePackage = (TypePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) instanceof TypePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TypePackage.eNS_URI) : TypePackage.eINSTANCE);
		UnitPackageImpl theUnitPackage = (UnitPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) instanceof UnitPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(UnitPackage.eNS_URI) : UnitPackage.eINSTANCE);
		VariablePackageImpl theVariablePackage = (VariablePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI) instanceof VariablePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(VariablePackage.eNS_URI) : VariablePackage.eINSTANCE);
		MemoryPackageImpl theMemoryPackage = (MemoryPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) instanceof MemoryPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(MemoryPackage.eNS_URI) : MemoryPackage.eINSTANCE);
		PeripheralPackageImpl thePeripheralPackage = (PeripheralPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI) instanceof PeripheralPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PeripheralPackage.eNS_URI) : PeripheralPackage.eINSTANCE);
		StimulationPackageImpl theStimulationPackage = (StimulationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI) instanceof StimulationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(StimulationPackage.eNS_URI) : StimulationPackage.eINSTANCE);
		SettingsPackageImpl theSettingsPackage = (SettingsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) instanceof SettingsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SettingsPackage.eNS_URI) : SettingsPackage.eINSTANCE);

		// Load packages
		theRootPackage.loadPackage();

		// Fix loaded packages
		theRequirementPackage.fixPackageContents();
		theRootPackage.fixPackageContents();
		theModelPackage.fixPackageContents();
		theAutosarPackage.fixPackageContents();
		theFmiPackage.fixPackageContents();
		theTypePackage.fixPackageContents();
		theUnitPackage.fixPackageContents();
		theVariablePackage.fixPackageContents();
		theMemoryPackage.fixPackageContents();
		thePeripheralPackage.fixPackageContents();
		theStimulationPackage.fixPackageContents();
		theSettingsPackage.fixPackageContents();

		// Mark meta-data to indicate it can't be changed
		theRequirementPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(RequirementPackage.eNS_URI, theRequirementPackage);
		return theRequirementPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallNestingRequirement() {
		if (callNestingRequirementEClass == null) {
			callNestingRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(0);
		}
		return callNestingRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCallNestingRequirement_Limit() {
        return (EAttribute)getCallNestingRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEvaluation() {
		if (evaluationEClass == null) {
			evaluationEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(1);
		}
		return evaluationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEvaluation_ProvidedBy() {
        return (EAttribute)getEvaluation().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEvaluation_TimeCreated() {
        return (EAttribute)getEvaluation().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEvaluation_Verdict() {
        return (EAttribute)getEvaluation().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventChainBreakOffRequirement() {
		if (eventChainBreakOffRequirementEClass == null) {
			eventChainBreakOffRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(2);
		}
		return eventChainBreakOffRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainBreakOffRequirement_EvaluateBreakOffAsSuccess() {
        return (EAttribute)getEventChainBreakOffRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainBreakOffRequirement_EventChain() {
        return (EReference)getEventChainBreakOffRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainBreakOffRequirement_IgnoreLastInstances() {
        return (EAttribute)getEventChainBreakOffRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainBreakOffRequirement_IgnoreNonSequential() {
        return (EAttribute)getEventChainBreakOffRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainBreakOffRequirement_IgnoreSkipped() {
        return (EAttribute)getEventChainBreakOffRequirement().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainBreakOffRequirement_RequiredLastStep() {
        return (EReference)getEventChainBreakOffRequirement().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventChainJoinRequirement() {
		if (eventChainJoinRequirementEClass == null) {
			eventChainJoinRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(3);
		}
		return eventChainJoinRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainJoinRequirement_AllowSameInstance() {
        return (EAttribute)getEventChainJoinRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainJoinRequirement_EventChain() {
        return (EReference)getEventChainJoinRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventChainMultipleProcessingRequirement() {
		if (eventChainMultipleProcessingRequirementEClass == null) {
			eventChainMultipleProcessingRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(4);
		}
		return eventChainMultipleProcessingRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainMultipleProcessingRequirement_EventChain() {
        return (EReference)getEventChainMultipleProcessingRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventChainTimingRequirement() {
		if (eventChainTimingRequirementEClass == null) {
			eventChainTimingRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(6);
		}
		return eventChainTimingRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainTimingRequirement_EventChain() {
        return (EReference)getEventChainTimingRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainTimingRequirement_FromStep() {
        return (EReference)getEventChainTimingRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainTimingRequirement_InstanceOffset() {
        return (EAttribute)getEventChainTimingRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventChainTimingRequirement_Strategy() {
        return (EAttribute)getEventChainTimingRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventChainTimingRequirement_ToStep() {
        return (EReference)getEventChainTimingRequirement().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventIEventJRequirement() {
		if (eventIEventJRequirementEClass == null) {
			eventIEventJRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(7);
		}
		return eventIEventJRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventIEventJRequirement_EndEvent() {
        return (EReference)getEventIEventJRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventIEventJRequirement_ParameterA() {
        return (EAttribute)getEventIEventJRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEventIEventJRequirement_ParameterB() {
        return (EAttribute)getEventIEventJRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventIEventJRequirement_StartEvent() {
        return (EReference)getEventIEventJRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventNetExecTimeRequirement() {
		if (eventNetExecTimeRequirementEClass == null) {
			eventNetExecTimeRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(8);
		}
		return eventNetExecTimeRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventNetExecTimeRequirement_End() {
        return (EReference)getEventNetExecTimeRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventNetExecTimeRequirement_Process() {
        return (EReference)getEventNetExecTimeRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventNetExecTimeRequirement_Start() {
        return (EReference)getEventNetExecTimeRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventTimingRequirement() {
		if (eventTimingRequirementEClass == null) {
			eventTimingRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(9);
		}
		return eventTimingRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventTimingRequirement_Trigger() {
        return (EReference)getEventTimingRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventTimingRequirement_Start() {
        return (EReference)getEventTimingRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEventTimingRequirement_Stop() {
        return (EReference)getEventTimingRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGroupOfRequirements() {
		if (groupOfRequirementsEClass == null) {
			groupOfRequirementsEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(10);
		}
		return groupOfRequirementsEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getGroupOfRequirements_Requirements() {
        return (EReference)getGroupOfRequirements().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIllegalEventRequirement() {
		if (illegalEventRequirementEClass == null) {
			illegalEventRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(11);
		}
		return illegalEventRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIllegalEventRequirement_Event() {
        return (EReference)getIllegalEventRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoadRequirement() {
		if (loadRequirementEClass == null) {
			loadRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(12);
		}
		return loadRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoadRequirement_Granularity() {
        return (EReference)getLoadRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLoadRequirement_Limit() {
        return (EAttribute)getLoadRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoadRequirement_LoadResource() {
        return (EReference)getLoadRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLoadRequirement_PrewarnMargin() {
        return (EAttribute)getLoadRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLoadRequirement_RelationalOperator() {
        return (EAttribute)getLoadRequirement().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLoadRequirement_Steps() {
        return (EAttribute)getLoadRequirement().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetExecTimeRequirement() {
		if (netExecTimeRequirementEClass == null) {
			netExecTimeRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(13);
		}
		return netExecTimeRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetExecTimeRequirement_Process() {
        return (EReference)getNetExecTimeRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNetSlackTimeRequirement() {
		if (netSlackTimeRequirementEClass == null) {
			netSlackTimeRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(15);
		}
		return netSlackTimeRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetSlackTimeRequirement_DeadlineDelta() {
        return (EReference)getNetSlackTimeRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetSlackTimeRequirement_DeadlineEvent() {
        return (EReference)getNetSlackTimeRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNetSlackTimeRequirement_Process() {
        return (EReference)getNetSlackTimeRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNetSlackTimeRequirement_Type() {
        return (EAttribute)getNetSlackTimeRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPeriodicEventRequirement() {
		if (periodicEventRequirementEClass == null) {
			periodicEventRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(16);
		}
		return periodicEventRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPeriodicEventRequirement_Event() {
        return (EReference)getPeriodicEventRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRecursionRequirement() {
		if (recursionRequirementEClass == null) {
			recursionRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(17);
		}
		return recursionRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecursionRequirement_Limit() {
        return (EAttribute)getRecursionRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRequirement() {
		if (requirementEClass == null) {
			requirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(18);
		}
		return requirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRequirement_Description() {
        return (EAttribute)getRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRequirement_Etag() {
        return (EAttribute)getRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRequirement_Evaluate() {
        return (EAttribute)getRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRequirement_ProvidedBy() {
        return (EAttribute)getRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRequirement_Show() {
        return (EAttribute)getRequirement().getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRequirement_Url() {
        return (EAttribute)getRequirement().getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getResponseTimeRequirement() {
		if (responseTimeRequirementEClass == null) {
			responseTimeRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(19);
		}
		return responseTimeRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getResponseTimeRequirement_Process() {
        return (EReference)getResponseTimeRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRtosFailureRequirement() {
		if (rtosFailureRequirementEClass == null) {
			rtosFailureRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(20);
		}
		return rtosFailureRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRtosFailureRequirement_EnabledRTOSFailures() {
        return (EAttribute)getRtosFailureRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRtosFailureRequirement_Blacklist() {
        return (EReference)getRtosFailureRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimingRequirement() {
		if (timingRequirementEClass == null) {
			timingRequirementEClass = (EClass)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(25);
		}
		return timingRequirementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTimingRequirement_Interval() {
        return (EReference)getTimingRequirement().getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimingRequirement_SuccessIfOutsideOfInterval() {
        return (EAttribute)getTimingRequirement().getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimingRequirement_PrewarnMarginAtLowerLimit() {
        return (EAttribute)getTimingRequirement().getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimingRequirement_PrewarnMarginAtUpperLimit() {
        return (EAttribute)getTimingRequirement().getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getEventChainStrategy() {
		if (eventChainStrategyEEnum == null) {
			eventChainStrategyEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(5);
		}
		return eventChainStrategyEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getNetSlackTimeRequirementType() {
		if (netSlackTimeRequirementTypeEEnum == null) {
			netSlackTimeRequirementTypeEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(14);
		}
		return netSlackTimeRequirementTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRelationalOperator() {
		if (relationalOperatorEEnum == null) {
			relationalOperatorEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(21);
		}
		return relationalOperatorEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRelationalOperatorLeGe() {
		if (relationalOperatorLeGeEEnum == null) {
			relationalOperatorLeGeEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(22);
		}
		return relationalOperatorLeGeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRelationalOperatorLtLeGtGe() {
		if (relationalOperatorLtLeGtGeEEnum == null) {
			relationalOperatorLtLeGtGeEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(23);
		}
		return relationalOperatorLtLeGtGeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getRTOSFailure() {
		if (rtosFailureEEnum == null) {
			rtosFailureEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(24);
		}
		return rtosFailureEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getVerdict() {
		if (verdictEEnum == null) {
			verdictEEnum = (EEnum)EPackage.Registry.INSTANCE.getEPackage(RequirementPackage.eNS_URI).getEClassifiers().get(26);
		}
		return verdictEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RequirementFactory getRequirementFactory() {
		return (RequirementFactory)getEFactoryInstance();
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isFixed = false;

	/**
	 * Fixes up the loaded package, to make it appear as if it had been programmatically built.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fixPackageContents() {
		if (isFixed) return;
		isFixed = true;
		fixEClassifiers();
	}

	/**
	 * Sets the instance class on the given classifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void fixInstanceClass(EClassifier eClassifier) {
		if (eClassifier.getInstanceClassName() == null) {
			eClassifier.setInstanceClassName("com.inchron.realtime.root.model.requirement." + eClassifier.getName());
			setGeneratedClassName(eClassifier);
		}
	}

} //RequirementPackageImpl
