/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation;

import com.inchron.realtime.root.model.TimeDistribution;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Elimination Filter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.EliminationFilter#getSourceGenerator <em>Source Generator</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.EliminationFilter#getTimeFrame <em>Time Frame</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getEliminationFilter()
 * @model
 * @generated
 */
public interface EliminationFilter extends StimulationFilter {
	/**
	 * Returns the value of the '<em><b>Source Generator</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source Generator</em>' reference.
	 * @see #setSourceGenerator(StimuliGenerator)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getEliminationFilter_SourceGenerator()
	 * @model
	 * @generated
	 */
	StimuliGenerator getSourceGenerator();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.EliminationFilter#getSourceGenerator <em>Source Generator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source Generator</em>' reference.
	 * @see #getSourceGenerator()
	 * @generated
	 */
	void setSourceGenerator(StimuliGenerator value);

	/**
	 * Returns the value of the '<em><b>Time Frame</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time Frame</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time Frame</em>' containment reference.
	 * @see #setTimeFrame(TimeDistribution)
	 * @see com.inchron.realtime.root.model.stimulation.StimulationPackage#getEliminationFilter_TimeFrame()
	 * @model containment="true"
	 * @generated
	 */
	TimeDistribution getTimeFrame();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.stimulation.EliminationFilter#getTimeFrame <em>Time Frame</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Frame</em>' containment reference.
	 * @see #getTimeFrame()
	 * @generated
	 */
	void setTimeFrame(TimeDistribution value);

} // EliminationFilter
