/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.stimulation.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class StimulationFactoryImpl extends EFactoryImpl implements StimulationFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static StimulationFactory init() {
		try {
			StimulationFactory theStimulationFactory = (StimulationFactory)EPackage.Registry.INSTANCE.getEFactory(StimulationPackage.eNS_URI);
			if (theStimulationFactory != null) {
				return theStimulationFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new StimulationFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimulationFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case StimulationPackage.BURST_PATTERN: return createBurstPattern();
			case StimulationPackage.BURST_PATTERN_GENERATOR: return createBurstPatternGenerator();
			case StimulationPackage.CSV_BASED_GENERATOR: return createCSVBasedGenerator();
			case StimulationPackage.COMPOSITE_SCENARIO: return createCompositeScenario();
			case StimulationPackage.DISTURBANCE_FILTER: return createDisturbanceFilter();
			case StimulationPackage.DRIFT_FILTER: return createDriftFilter();
			case StimulationPackage.ELIMINATION_FILTER: return createEliminationFilter();
			case StimulationPackage.INDUCED_GENERATOR: return createInducedGenerator();
			case StimulationPackage.INDUCED_LIST_BASED_GENERATOR: return createInducedListBasedGenerator();
			case StimulationPackage.LIST_BASED_GENERATOR: return createListBasedGenerator();
			case StimulationPackage.RANDOM_STIMULI_GENERATOR: return createRandomStimuliGenerator();
			case StimulationPackage.STIMULATION_SCENARIO: return createStimulationScenario();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BurstPattern createBurstPattern() {
		BurstPatternImpl burstPattern = new BurstPatternImpl();
		return burstPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BurstPatternGenerator createBurstPatternGenerator() {
		BurstPatternGeneratorImpl burstPatternGenerator = new BurstPatternGeneratorImpl();
		return burstPatternGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CSVBasedGenerator createCSVBasedGenerator() {
		CSVBasedGeneratorImpl csvBasedGenerator = new CSVBasedGeneratorImpl();
		return csvBasedGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeScenario createCompositeScenario() {
		CompositeScenarioImpl compositeScenario = new CompositeScenarioImpl();
		return compositeScenario;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DisturbanceFilter createDisturbanceFilter() {
		DisturbanceFilterImpl disturbanceFilter = new DisturbanceFilterImpl();
		return disturbanceFilter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DriftFilter createDriftFilter() {
		DriftFilterImpl driftFilter = new DriftFilterImpl();
		return driftFilter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EliminationFilter createEliminationFilter() {
		EliminationFilterImpl eliminationFilter = new EliminationFilterImpl();
		return eliminationFilter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InducedGenerator createInducedGenerator() {
		InducedGeneratorImpl inducedGenerator = new InducedGeneratorImpl();
		return inducedGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InducedListBasedGenerator createInducedListBasedGenerator() {
		InducedListBasedGeneratorImpl inducedListBasedGenerator = new InducedListBasedGeneratorImpl();
		return inducedListBasedGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ListBasedGenerator createListBasedGenerator() {
		ListBasedGeneratorImpl listBasedGenerator = new ListBasedGeneratorImpl();
		return listBasedGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomStimuliGenerator createRandomStimuliGenerator() {
		RandomStimuliGeneratorImpl randomStimuliGenerator = new RandomStimuliGeneratorImpl();
		return randomStimuliGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimulationScenario createStimulationScenario() {
		StimulationScenarioImpl stimulationScenario = new StimulationScenarioImpl();
		return stimulationScenario;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimulationPackage getStimulationPackage() {
		return (StimulationPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static StimulationPackage getPackage() {
		return StimulationPackage.eINSTANCE;
	}

} //StimulationFactoryImpl
