/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.impl.ModelObjectImpl;

import com.inchron.realtime.root.model.stimulation.BurstPattern;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;
import com.inchron.realtime.root.model.stimulation.StimulationScenario;
import com.inchron.realtime.root.model.stimulation.StimuliGenerator;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Scenario</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.StimulationScenarioImpl#getBurstPattern <em>Burst Pattern</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.StimulationScenarioImpl#getGenerators <em>Generators</em>}</li>
 * </ul>
 *
 * @generated
 */
public class StimulationScenarioImpl extends ModelObjectImpl implements StimulationScenario {
	/**
	 * The cached value of the '{@link #getBurstPattern() <em>Burst Pattern</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBurstPattern()
	 * @generated
	 * @ordered
	 */
	protected BurstPattern burstPattern;

	/**
	 * The cached value of the '{@link #getGenerators() <em>Generators</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGenerators()
	 * @generated
	 * @ordered
	 */
	protected EList<StimuliGenerator> generators;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected StimulationScenarioImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.STIMULATION_SCENARIO;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BurstPattern getBurstPattern() {
		return burstPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetBurstPattern(BurstPattern newBurstPattern, NotificationChain msgs) {
		BurstPattern oldBurstPattern = burstPattern;
		burstPattern = newBurstPattern;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN, oldBurstPattern, newBurstPattern);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setBurstPattern(BurstPattern newBurstPattern) {
		if (newBurstPattern != burstPattern) {
			NotificationChain msgs = null;
			if (burstPattern != null)
				msgs = ((InternalEObject)burstPattern).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN, null, msgs);
			if (newBurstPattern != null)
				msgs = ((InternalEObject)newBurstPattern).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN, null, msgs);
			msgs = basicSetBurstPattern(newBurstPattern, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN, newBurstPattern, newBurstPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<StimuliGenerator> getGenerators() {
		if (generators == null) {
			generators = new EObjectContainmentEList<StimuliGenerator>(StimuliGenerator.class, this, StimulationPackage.STIMULATION_SCENARIO__GENERATORS);
		}
		return generators;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN:
				return basicSetBurstPattern(null, msgs);
			case StimulationPackage.STIMULATION_SCENARIO__GENERATORS:
				return ((InternalEList<?>)getGenerators()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN:
				return getBurstPattern();
			case StimulationPackage.STIMULATION_SCENARIO__GENERATORS:
				return getGenerators();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN:
				setBurstPattern((BurstPattern)newValue);
				return;
			case StimulationPackage.STIMULATION_SCENARIO__GENERATORS:
				getGenerators().clear();
				getGenerators().addAll((Collection<? extends StimuliGenerator>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN:
				setBurstPattern((BurstPattern)null);
				return;
			case StimulationPackage.STIMULATION_SCENARIO__GENERATORS:
				getGenerators().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.STIMULATION_SCENARIO__BURST_PATTERN:
				return burstPattern != null;
			case StimulationPackage.STIMULATION_SCENARIO__GENERATORS:
				return generators != null && !generators.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //StimulationScenarioImpl
