/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.settings.impl;

import com.inchron.realtime.root.model.TraceEventType;

import com.inchron.realtime.root.settings.Color;
import com.inchron.realtime.root.settings.SettingsPackage;
import com.inchron.realtime.root.settings.TraceEventTypeConfiguration;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Trace Event Type Configuration</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl#getColor <em>Color</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl#getTraceEventType <em>Trace Event Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.settings.impl.TraceEventTypeConfigurationImpl#isVisible <em>Visible</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TraceEventTypeConfigurationImpl extends MinimalEObjectImpl.Container implements TraceEventTypeConfiguration {
	/**
	 * The cached value of the '{@link #getColor() <em>Color</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getColor()
	 * @generated
	 * @ordered
	 */
	protected Color color;

	/**
	 * The default value of the '{@link #getTraceEventType() <em>Trace Event Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTraceEventType()
	 * @generated
	 * @ordered
	 */
	protected static final TraceEventType TRACE_EVENT_TYPE_EDEFAULT = TraceEventType.ACTIVATE;

	/**
	 * The cached value of the '{@link #getTraceEventType() <em>Trace Event Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTraceEventType()
	 * @generated
	 * @ordered
	 */
	protected TraceEventType traceEventType = TRACE_EVENT_TYPE_EDEFAULT;

	/**
	 * The default value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected static final boolean VISIBLE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected boolean visible = VISIBLE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TraceEventTypeConfigurationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SettingsPackage.Literals.TRACE_EVENT_TYPE_CONFIGURATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Color getColor() {
		if (color != null && color.eIsProxy()) {
			InternalEObject oldColor = (InternalEObject)color;
			color = (Color)eResolveProxy(oldColor);
			if (color != oldColor) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__COLOR, oldColor, color));
			}
		}
		return color;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Color basicGetColor() {
		return color;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setColor(Color newColor) {
		Color oldColor = color;
		color = newColor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__COLOR, oldColor, color));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TraceEventType getTraceEventType() {
		return traceEventType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTraceEventType(TraceEventType newTraceEventType) {
		TraceEventType oldTraceEventType = traceEventType;
		traceEventType = newTraceEventType == null ? TRACE_EVENT_TYPE_EDEFAULT : newTraceEventType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE, oldTraceEventType, traceEventType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isVisible() {
		return visible;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setVisible(boolean newVisible) {
		boolean oldVisible = visible;
		visible = newVisible;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE, oldVisible, visible));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__COLOR:
				if (resolve) return getColor();
				return basicGetColor();
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE:
				return getTraceEventType();
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE:
				return isVisible();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__COLOR:
				setColor((Color)newValue);
				return;
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE:
				setTraceEventType((TraceEventType)newValue);
				return;
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE:
				setVisible((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__COLOR:
				setColor((Color)null);
				return;
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE:
				setTraceEventType(TRACE_EVENT_TYPE_EDEFAULT);
				return;
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE:
				setVisible(VISIBLE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__COLOR:
				return color != null;
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__TRACE_EVENT_TYPE:
				return traceEventType != TRACE_EVENT_TYPE_EDEFAULT;
			case SettingsPackage.TRACE_EVENT_TYPE_CONFIGURATION__VISIBLE:
				return visible != VISIBLE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (traceEventType: ");
		result.append(traceEventType);
		result.append(", visible: ");
		result.append(visible);
		result.append(')');
		return result.toString();
	}

} //TraceEventTypeConfigurationImpl
