 /**
 ********************************************************************************
 * Copyright (c) 2017 - 2018 Robert Bosch GmbH.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */
package org.eclipse.app4mc.emfutils.content.extractor.preferences;

import org.eclipse.app4mc.emfutils.content.extractor.Activator;
import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 *
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	@Override
	public void initializeDefaultPreferences() {
		
		
		final IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.P_DOT_PATH, store.getString(PreferenceConstants.P_DOT_PATH) != null
				? store.getString(PreferenceConstants.P_DOT_PATH) : "");
		store.setDefault(PreferenceConstants.P_FOLDER_PATH, store.getString(PreferenceConstants.P_FOLDER_PATH) != null
				? store.getString(PreferenceConstants.P_FOLDER_PATH) : "");

		store.setDefault(PreferenceConstants.P_DRILL_DOWN, store.getBoolean(PreferenceConstants.P_DRILL_DOWN));

		store.setDefault(PreferenceConstants.P_REDRAW_TREE_ON_SELECTION,
				store.contains(PreferenceConstants.P_REDRAW_TREE_ON_SELECTION)
						? store.getBoolean(PreferenceConstants.P_REDRAW_TREE_ON_SELECTION) : false);
	}

}
