/**
 * *******************************************************************************
 * Copyright (c) 2019 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 * *******************************************************************************
 */

package templates.m2m.constraints

import com.google.inject.Inject
import com.google.inject.Singleton
import templates.AbstractAmaltheaInchronTransformer
import templates.m2m.constraints.EventChainTransformer
import org.eclipse.app4mc.amalthea.model.EventChain

@Singleton
class ConstraintsTransformer extends AbstractAmaltheaInchronTransformer {
	
	@Inject EventChainTransformer eventChainTransformer

	def transformConstraintsModel() {
		getAmaltheaRoot()?.constraintsModel?.eventChains?.forEach(EventChain eventChain | {
			eventChainTransformer.createDataFlow(eventChain);
		})		
	}

}
