/**
 ********************************************************************************
 * Copyright (c) 2017 Robert Bosch GmbH and others.
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     Robert Bosch GmbH - initial API and implementation
 ********************************************************************************
 */
package org.eclipse.app4mc.sca.ui.preferences;

import java.util.Arrays;
import java.util.List;

import org.eclipse.app4mc.sca.ui.preferences.interfaces.IExportPreferences;
import org.eclipse.app4mc.sca.ui.util.SCAToolsPreferenceConstants;
import org.eclipse.jface.preference.IPreferenceStore;

/**
 * The list of preferences that are exported for the tool SCA as options file
 */
public class SCAExportPreferenceList implements IExportPreferences {

  /**
   * Private constructor
   */
  public SCAExportPreferenceList() {
    // Nothing now
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public List<String> keysToExport() {
    String[] prefToSave = { // NOSONAR not significant
        SCAToolsPreferenceConstants.TEXT_LOGFILENAME,
        SCAToolsPreferenceConstants.DEBUG_MODE };
    return Arrays.asList(prefToSave);
  }

  /**
   * {@inheritDoc}
   */
  @Override
  public IPreferenceStore getPreferenceStore() {
    return org.eclipse.app4mc.sca.util.Activator.getDefault().getPreferenceStore();
  }

}
